IF OBJECT_ID(N'PK4_6') IS NOT NULL
ALTER TABLE [dbo].[perfil_centro] DROP CONSTRAINT [PK4_6] 

GO

if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfiles'   
                  and c.name='empresas')  
  ALTER TABLE perfiles alter column empresas varchar(650) NULL 
GO  

if exists (SELECT * 
    FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS
    WHERE CONSTRAINT_NAME='PK7_4' )

ALTER TABLE [dbo].[opciones] drop CONSTRAINT PK7_4
GO


if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='opciones'   
                  and c.name='opcion')  
  ALTER TABLE opciones alter column opcion char(3) null  
GO  

if exists (SELECT * 
    FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS
    WHERE CONSTRAINT_NAME='PK8_3' )

ALTER TABLE [dbo].perfil_funcion drop CONSTRAINT PK8_3
GO

if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfil_funcion'   
                  and c.name='opcion')  
  ALTER TABLE perfil_funcion alter column opcion char(3) NULL 
GO  


if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfiles'   
                  and c.name='nomina')  
  ALTER TABLE perfiles alter column nomina varchar(150) NULL 
GO 


IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'email' and sysobjects.name='usuarios')
Alter table usuarios add email varchar(250) null    
              
GO

Update bitacora set sistema='NO' where sistema is null
GO

IF OBJECT_ID(N'dbo.AccesoaFunciones') IS NOT NULL 
    DROP FUNCTION dbo.AccesoaFunciones
GO

CREATE FUNCTION dbo.AccesoaFunciones ( @idperfil INT )
RETURNS VARCHAR(500)
AS 
    BEGIN
        DECLARE @cfunciones VARCHAR(500)
        DECLARE @cfuncion VARCHAR(5)
        SET @cfunciones = ''
        DECLARE funcionesCursor CURSOR FOR
        SELECT DISTINCT(RTRIM(z.funcion)+',') FROM perfil_funcion AS Z WHERE @idperfil=Z.idperfil
        OPEN funcionesCursor
        FETCH NEXT FROM funcionesCursor
  INTO @cfuncion
        WHILE @@fetch_status = 0 
            BEGIN
                SET @cfunciones = @cfunciones + @cfuncion
                FETCH NEXT FROM funcionesCursor
		INTO @cfuncion
            END
        CLOSE funcionesCursor
        DEALLOCATE funcionesCursor	
        RETURN @cfunciones 
    END
GO

IF OBJECT_ID(N'dbo.AccesoaOpciones') IS NOT NULL 
    DROP FUNCTION dbo.AccesoaOpciones
GO

CREATE FUNCTION dbo.AccesoaOpciones
    (
      @sistema VARCHAR(5) ,
      @usuario VARCHAR(30) ,
      @funcion VARCHAR(5)
    )
RETURNS VARCHAR(500)
AS 
    BEGIN
        DECLARE @cOpciones VARCHAR(500)
        DECLARE @cOpcion VARCHAR(5)
        SET @cOpciones = ''
        DECLARE OpcionesCursor CURSOR FOR
        SELECT c.opcion+ ','  FROM perfiles AS a
        LEFT JOIN perfil_usuarios AS b ON a.idperfil=b.idperfil
        LEFT JOIN perfil_funcion AS c ON b.idperfil=c.idperfil
        WHERE a.sistema=@sistema AND b.usuario=@usuario AND c.funcion=@funcion
        OPEN OpcionesCursor
        FETCH NEXT FROM OpcionesCursor
  INTO @cOpcion
        WHILE @@fetch_status = 0 
            BEGIN
                SET @cOpciones = @cOpciones + @cOpcion
                FETCH NEXT FROM OpcionesCursor
		INTO @cOpcion
            END
        CLOSE OpcionesCursor
        DEALLOCATE OpcionesCursor
        RETURN @cOpciones 
    END
GO

IF not EXISTS(select syscolumns.name  from syscolumns
left join sysobjects on syscolumns.id= sysobjects.id
where syscolumns.name = 'empresa' and sysobjects.name='perfil_centro')
Alter table perfil_centro add empresa bigint null

Go

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[perfil_reporte]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)  
CREATE TABLE [dbo].[perfil_reporte](
	[reporte] [varchar](100) NULL,
	[idPerfil] [bigint] NULL,
	[empresa] [bigint] NULL
) ON [PRIMARY]

GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosValidaEmpresaCentro'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosValidaEmpresaCentro
GO

CREATE PROCEDURE dbo.usuariosValidaEmpresaCentro

AS 
    
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
    declare @vcentro as varchar(50)
    declare @vIdPerfil as bigint
    declare @vIdEmpresa as bigint
	
	DECLARE Centro_cursor CURSOR FOR 
	select centro, idperfil
	from perfil_centro
	where empresa is null
	
	OPEN Centro_cursor
	FETCH NEXT FROM Centro_cursor INTO @vcentro,@vidperfil
	WHILE @@FETCH_STATUS = 0
	BEGIN
	
		set @vIdEmpresa = 0
		
		select @vIdEmpresa=empresa
		from centros	
		where centro=@vcentro
		
		if @vIdEmpresa<>0
			begin
				update perfil_centro
				set empresa=@vIdEmpresa
				where centro=@vcentro
				and idperfil=@vIdPerfil
			end
		

		FETCH NEXT FROM Centro_cursor INTO @vcentro,@vidperfil
	END    
	DEALLOCATE Centro_cursor
GO

exec usuariosValidaEmpresaCentro

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'userPasswordLength'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.userPasswordLength
GO

CREATE PROCEDURE dbo.userPasswordLength

AS
SET NOCOUNT ON
SET DATEFORMAT MDY

Select longitud_password from ctrl_usuarios

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'userDelete'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.userDelete
GO
create PROCEDURE dbo.userDelete
@usuario VARCHAR(20)
AS
SET NOCOUNT ON
SET DATEFORMAT MDY

delete from hpwd where usuario=@usuario
delete from perfil_usuarios where usuario=@usuario
Delete from usuarios where usuario=@usuario
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosPerfilesAsignadosAUsuarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosPerfilesAsignadosAUsuarios
GO
create PROCEDURE dbo.usuariosPerfilesAsignadosAUsuarios
( @idUsuario varchar(30))
AS
BEGIN 
	Select  sistema.nombre, 
			perfil_usuarios.idPerfil, 
			perfiles.Descripcion  
	from perfil_usuarios 
		left join  perfiles on perfil_usuarios.idperfil=perfiles.idperfil
		left join Sistema on perfiles.sistema=sistema.sistema			
	where usuario=@idusuario 
END
            
GO            

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosListaPerfiles'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosListaPerfiles
GO
create PROCEDURE dbo.usuariosListaPerfiles

AS
BEGIN 
	Select  sistema.nombre, 
			perfil_usuarios.idPerfil, 
			perfiles.Descripcion  
	from perfil_usuarios 
		left join  perfiles on perfil_usuarios.idperfil=perfiles.idperfil
		left join Sistema on perfiles.sistema=sistema.sistema			
	
END
            
GO   

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosDetalleUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosDetalleUsuario
GO
create PROCEDURE dbo.usuariosDetalleUsuario
( @idusuario varchar(50))
AS
BEGIN 
	Select  usuario,
			descripcion,
			password,
			expiracion,
			email
	from usuarios 
	where usuario=@idUsuario
	
END
            
GO               

IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'especiales' and sysobjects.name='Ctrl_usuarios')
Alter table Ctrl_usuarios add especiales numeric(2,0) null    
              
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'mayusculas' and sysobjects.name='Ctrl_usuarios')
Alter table Ctrl_usuarios add mayusculas numeric(2,0) null    
              
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'minusculas' and sysobjects.name='Ctrl_usuarios')
Alter table Ctrl_usuarios add minusculas numeric(2,0) null    
              
GO

UPDATE Ctrl_usuarios set especiales=0 where especiales is null
UPDATE Ctrl_usuarios set mayusculas=0 where mayusculas is null
UPDATE Ctrl_usuarios set minusculas=0 where minusculas is null
GO

IF EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='A' and opcion='A1')	
	update opciones set descripcion= 'Consultar' where opcion='A1' and sistema='TP' and funcion='A'
GO

IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='A' and opcion='A1' AND descripcion='Consultar' )	
	INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('A1','TP','A','Consultar')	
GO

IF EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='A' and opcion='A2')	
	update opciones set descripcion= 'Solicitar Vacaciones' where opcion='A2' and sistema='TP' and funcion='A'
GO

IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='A' and opcion='A2' AND descripcion='Solicitar Vacaciones' )	
	INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('A2','TP','A','Solicitar Vacaciones')
GO

IF EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='A' and opcion='A3')	
	update opciones set descripcion= 'Ver Proporcionales' where opcion='A3' and sistema='TP' and funcion='A'
GO	

IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='A' and opcion='A3' AND descripcion='Ver Proporcionales' )	
	INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('A3','TP','A','Ver Proporcionales')	
	
GO	

IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='TP' AND FUNCION='R'  )	
	INSERT INTO funciones (sistema,funcion,descripcion)  VALUES ('TP','R','Reportes')	
	
GO

IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='R' and opcion='R1'  )	
	INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('R1','TP','R','Reportes')	
	
GO

IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='R' and opcion='R2'  )	
	INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('R2','TP','R','Constancia Laboral')	
	
GO	

IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='R' and opcion='R3'  )	
	INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('R3','TP','R','Formato Vacaciones')	
	
GO		

IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='R' and opcion='R4' )	
	INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('R4','TP','R','Movimientos del IMSS')	
	
GO	

IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='R' and opcion='R5'  )	
	INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('R5','TP','R','Movimientos de Sueldo')	
	
GO	

IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='R' and opcion='R6'  )	
	INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('R6','TP','R','Constancia Antiguedad')	
	
GO	

IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='R' and opcion='R7'  )	
	INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('R7','TP','R','Prestamos Infonavit')	
	
GO	

IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='R' and opcion='R8' )	
	INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('R8','TP','R','Otros Prestamos')	
	
GO	

IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='R' and opcion='R9'  )	
	INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('R9','TP','R','Prestamos de Fondo de Ahorro')	
	
GO

IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='R' and opcion='R10'  )	
	INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('R10','TP','R','Cursos Tomados')	
GO	

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'insertaPermisosReportesAPerfilesExistentes'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.insertaPermisosReportesAPerfilesExistentes
GO
create PROCEDURE dbo.insertaPermisosReportesAPerfilesExistentes

AS
BEGIN 

	declare @existePermiso int
	
	select @existePermiso=count(idperfil)
	from perfil_funcion
	where idperfil in (select idperfil from perfiles where sistema='TP')
	and funcion='R' and opcion='R2'
	
	if @existePermiso=0
		begin
			insert into perfil_funcion 
			select 'R','R2', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R3', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R4', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R5', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R6', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R7', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R8', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R9', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R10', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'A','A3', idperfil from perfiles where sistema='TP'
		end

END
            
GO 

exec insertaPermisosReportesAPerfilesExistentes
GO