
IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'[dbo].[PortalEmpleadoConfigSolicitudes]')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE [dbo].[PortalEmpleadoConfigSolicitudes]
            (
              [empresa] [numeric](5,0) NOT NULL,
              [EnvioCorreo] VARCHAR(2) NULL,
			  [Supervisor] VARCHAR(2) NULL,
                CONSTRAINT [pk_PortalEmpleadoConfigSolicitudes]
                PRIMARY KEY CLUSTERED ( [empresa] ASC )
            )
        ON  [PRIMARY]
     
    END

GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'[dbo].[PortalEmpleadoPoliticas]')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 

CREATE TABLE [dbo].[PortalEmpleadoPoliticas](
	[idempresa] [bigint] NULL,
	[idPolitica] [bigint] NULL,
	[nombrePolitica] [varchar](50) NULL,
	[ubicacion] [varchar](500) NULL
) ON [PRIMARY]

GO

iF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'[dbo].[configuraOpcionVacacionesPE]')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN

		CREATE TABLE [dbo].[configuraOpcionVacacionesPE](
			[idempresa] [bigint] NOT NULL,
			[opcion] [int] NULL,
		 CONSTRAINT [PK_configuraOpcionVacacionesPE] PRIMARY KEY CLUSTERED 
		(
			[idempresa] ASC
		)
		) ON [PRIMARY]

    END

GO

iF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'[dbo].[PortalEmpleadoLogo]')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
		CREATE TABLE [dbo].[PortalEmpleadoLogo](
			[idEmpresa] [bigint] NOT NULL,
			[rutaImagen] [varchar](max) NULL,
			[rutaFirma] [varchar](max) NULL,
		 CONSTRAINT [PK_PortalEmpleadoLogo] PRIMARY KEY CLUSTERED 
		(
			[idEmpresa] ASC
		)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
		) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

    END

GO
     
IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'PortalEmpleadoGuardaConfiguracionVacaciones' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoGuardaConfiguracionVacaciones
    
GO

CREATE PROCEDURE dbo.PortalEmpleadoGuardaConfiguracionVacaciones
(
	@idEmpresa bigint,
	@opcion int
)

	with ENCRYPTION
AS
	begin
	
	if exists (select idempresa from configuraOpcionVacacionesPE where idempresa=@idempresa)
		begin
			update configuraOpcionVacacionesPE set opcion=@opcion where idempresa=@idempresa
		end
		
	 if not exists (select idempresa from configuraOpcionVacacionesPE where idempresa=@idempresa)
		begin
			insert into configuraOpcionVacacionesPE values (@idEmpresa,@opcion)
		end
		
	end

GO

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'PortalEmpleadoInicializaConfiguracionVacaciones' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoInicializaConfiguracionVacaciones
    
GO

CREATE PROCEDURE dbo.PortalEmpleadoInicializaConfiguracionVacaciones
( @IdEmpresa bigint )

	with ENCRYPTION
AS
	BEGIN
		
	if not exists (select idempresa from configuraOpcionVacacionesPE where idempresa=@idempresa)
		begin
			insert into configuraOpcionVacacionesPE values (@idEmpresa,1)
		end
		
	END
GO

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'peCargaOpcionVacaciones' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.peCargaOpcionVacaciones
    
GO
CREATE PROCEDURE dbo.peCargaOpcionVacaciones
(
	@idEmpresa bigint
)

	with ENCRYPTION
AS
	begin
		select isnull(opcion,0) from configuraOpcionVacacionesPE where idempresa=@idempresa
	end
GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'CodigoBloquea'
                        AND sysobjects.name = 'PortalEmpleadoConfigSolicitudes' ) 
    ALTER TABLE PortalEmpleadoConfigSolicitudes ADD CodigoBloquea bigint NULL 
GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'AutorizaPorMail'
                        AND sysobjects.name = 'PortalEmpleadoConfigSolicitudes' ) 
    ALTER TABLE PortalEmpleadoConfigSolicitudes ADD AutorizaPorMail int NULL 
GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'url'
                        AND sysobjects.name = 'PortalEmpleadoConfigSolicitudes' ) 
    ALTER TABLE PortalEmpleadoConfigSolicitudes ADD url varchar(max) NULL 

GO


IF NOT EXISTS ( SELECT  *
                 FROM    dbo.sysobjects
                 WHERE   id = OBJECT_ID(N'[dbo].[perfil_empleado]')
                         AND OBJECTPROPERTY(id, N'IsUserTable') = 1 )
     BEGIN
     
		 CREATE TABLE [dbo].[perfil_empleado](
			[idPerfil] [bigint] NOT NULL,
			[empresa] [bigint] NOT NULL,
			[codigo] [numeric](8, 0) NOT NULL,
		 CONSTRAINT [PK_perfil_empleado] PRIMARY KEY CLUSTERED 
		(
			[idPerfil] ASC,
			[empresa] ASC,
			[codigo] ASC
		) ON [PRIMARY]
		) ON [PRIMARY]
		     
     end
GO



IF NOT EXISTS ( SELECT  *
                 FROM    dbo.sysobjects
                 WHERE   id = OBJECT_ID(N'[dbo].[perfil_Insertado]')
                         AND OBJECTPROPERTY(id, N'IsUserTable') = 1 )
     BEGIN
     
		 CREATE TABLE [dbo].[perfil_Insertado](
			[modulo] varchar(20) NULL,
			[insertado] [int] default 0
		) ON [PRIMARY]
		 
		 
		insert into perfil_Insertado values('PortalEmpleado',0)	 
		    
     end
GO

     
IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'PortalEmpleadoObtenPeriodosRecibos' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoObtenPeriodosRecibos
GO

CREATE PROCEDURE dbo.PortalEmpleadoObtenPeriodosRecibos
(
	@ayo udtInteger,
	@tiponom udtInteger,
	@codigo udtlong,
	@llave udtLong
)

	with ENCRYPTION
AS

	SELECT  LTRIM(STR(kardex_anual.periodo)) AS periodo
	FROM kardex_anual 
			LEFT JOIN tmpAccesoPortalPatron ON kardex_anual.empresa = tmpAccesoPortalPatron.empresa 
	WHERE kardex_anual.ayo_operacion =@ayo
			AND kardex_anual.tiponom=@tiponom
			and kardex_anual.codigo=@codigo
			AND tmpAccesoPortalPatron.llave=@llave
	GROUP BY kardex_anual.periodo
	ORDER BY kardex_anual.periodo asc

GO

     
IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'PortalPatronObtenPeriodosRecibos' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.PortalPatronObtenPeriodosRecibos
GO

CREATE PROCEDURE dbo.PortalPatronObtenPeriodosRecibos
(
	@ao udtInteger,
	@tiponom udtInteger,
	@llave udtLong
)

	with ENCRYPTION
AS

SELECT REPLICATE('0',2 - LEN(LTRIM(STR(k.periodo))) )+ LTRIM(STR(k.periodo)) AS periodo
FROM dbo.kardex_anual AS k
INNER JOIN dbo.tmpAccesoPortalPatron AS tmp ON k.empresa = tmp.empresa AND tmp.llave=@llave
WHERE k.ayo_operacion=@ao AND k.tiponom=@tiponom
GROUP BY k.periodo
ORDER BY k.periodo DESC

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalEmpleadoCargaRecibosYear'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoCargaRecibosYear
GO

CREATE PROCEDURE dbo.PortalEmpleadoCargaRecibosYear
(
	@llave udtLong,
	@codigo udtlong
)
    with ENCRYPTION
AS 
    SELECT DISTINCT
            ( k.ayo_operacion )
    FROM    dbo.kardex_anual AS k
		INNER JOIN dbo.tmpAccesoPortalPatron AS tmp ON k.empresa = tmp.empresa AND tmp.llave=@llave
    where k.codigo=@codigo
    ORDER BY k.ayo_operacion DESC

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalPatronInsertaEmpresasSeleccionadas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalPatronInsertaEmpresasSeleccionadas
GO

CREATE PROCEDURE [dbo].PortalPatronInsertaEmpresasSeleccionadas
(	@llave bigint,
	@empresa bigint )
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  

	insert into tmpAccesoPortalPatron values (@llave, @empresa)

	
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalPatronBorraEmpresasSeleccionadas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalPatronBorraEmpresasSeleccionadas
GO

CREATE PROCEDURE [dbo].PortalPatronBorraEmpresasSeleccionadas
(	@llave bigint )
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  

	delete from  tmpAccesoPortalPatron 
	where llave = @llave

	
GO

IF NOT EXISTS ( SELECT  *
                 FROM    dbo.sysobjects
                 WHERE   id = OBJECT_ID(N'[dbo].[PortalEmpleadoConfig]')
                         AND OBJECTPROPERTY(id, N'IsUserTable') = 1 )
     BEGIN
         CREATE TABLE [dbo].[PortalEmpleadoConfig]
             (
               [llave] [int] NOT NULL
                             IDENTITY ,
               [emps_todas] VARCHAR(1)
                 NULL
                 CONSTRAINT [pk_PortalEmpleadoConfig]
                 PRIMARY KEY CLUSTERED ( [llave] ASC )
             )
         ON  [PRIMARY]


         INSERT  INTO dbo.PortalEmpleadoConfig
                 ( emps_todas )
         VALUES  ( 'N' )
     END

GO	   	   	   

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'[dbo].[employyedecrypPassword]')
                    AND xtype IN ( N'FN', N'IF', N'TF' ) ) 
    DROP FUNCTION [dbo].employyedecrypPassword

GO

CREATE FUNCTION [dbo].employyedecrypPassword
    (
      @password AS VARCHAR(30)
    )
RETURNS VARCHAR(30)
    WITH ENCRYPTION
AS 
    BEGIN

        DECLARE @vClave AS udtStringSize4096

        SET @vClave = @password

        DECLARE @nCtr AS udtLong ,
            @nTemp AS udtLong ,
            @nOffset AS udtLong ,
            @sPwdTemp AS udtStringSize4096 ,
            @sCodTemp AS udtStringSize4096

        SET @sPwdTemp = @vClave
        SET @sCodTemp = ''
        SET @nCtr = 1
   
        WHILE @nCtr <= LEN(@sPwdTemp) 
            BEGIN
                SET @nOffset = @nCtr % 3
                SET @nTemp = ASCII(SUBSTRING(@sPwdTemp, @nCtr, 1))
                SET @sCodTemp = @sCodTemp + CHAR(( @nTemp - 10 + @nOffset ))
                SET @nCtr = @nCtr + 1
            END

        RETURN( @sCodTemp )

    END
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peGetCompanyInformation'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.peGetCompanyInformation
GO


CREATE PROCEDURE  dbo.peGetCompanyInformation
    (
		@companyId AS bigint 
    )

AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    
    SELECT
		empresas.nombre_empresa,
		empresas.rfc_empresa,
		empresas.registro_patronal,
		isnull(rtrim(empresas.direccion_empresa),'') + ' ' + isnull(RTRIM(empresas.colonia_empresa),'') as direccion,
		isnull(rtrim(empresas.poblacion_empresa),'') + ' ' + isnull(RTRIM(nomentidad),'')	as entidad
	FROM
		empresas 
	WHERE
		empresas.empresa = @companyId 	
	    
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peCargaNombreEmpresa'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.peCargaNombreEmpresa
GO
CREATE PROCEDURE [dbo].peCargaNombreEmpresa
    (@companyId as bigint)
AS 
	BEGIN
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
	Select nombre_empresa from empresas where empresa= @companyId
   END
GO
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peCargaNombreEmpresa'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.peCargaNombreEmpresa
GO
CREATE PROCEDURE [dbo].peCargaNombreEmpresa
    (@companyId as bigint,
     @codigo as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
	select rtrim(nombre) + ' ' + rtrim(ap_paterno) + ' ' + rtrim(ap_materno) 
	from empleados
    where codigo= @codigo
    and empresa=@companyId
 GO
 
 IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peCargaListadoEmpresas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.peCargaListadoEmpresas
GO
CREATE PROCEDURE [dbo].peCargaListadoEmpresas

AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
	select rtrim(convert(varchar(10),empresa)) + ' - ' + rtrim(isnull(nombre_empresa,'')) + ' - ' + RTRIM(isnull(referencia,'')),
	empresa
	from empresas

 GO
  
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peCargaFunciones'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.peCargaFunciones
GO
CREATE PROCEDURE [dbo].peCargaFunciones
    
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
    declare @existe as char(2)
    declare @existe2 as char(2)
    declare @existe3 as char(2)
    DECLARE @IDPERFIL AS BIGINT
    
    Select @existe=count(NOMBRE) from sistema where sistema ='TP'    
    Select @existe2=count(opcion) from opciones where sistema ='TP' and funcion='E' and opcion='E1' 
    select @existe3=count(idperfil) from perfiles where descripcion = 'Admin. Portal del Trabajador'

	if (@EXISTE=0 and @existe2=0)
	BEGIN
		insert into sistema values ('TP','PORTAL DEL TRABAJADOR')
		insert into perfiles values ('Admin. Portal del Trabajador','TP','{}','{}','N','N',null)
		
		insert into funciones values ('TP', 'A' , 'Vacaciones') 
		insert into funciones values ('TP', 'B' , 'Ausentismo') 
		insert into funciones values ('TP', 'C' , 'Recibos') 
		insert into funciones values ('TP', 'R' , 'Imprimir Reportes') 
		insert into funciones values ('TP', 'E' , 'Tiempo Extra') 
		insert into funciones values ('TP', 'F' , 'Datos Personales') 
		insert into funciones values ('TP', 'G' , 'Datos Nmina') 
		
		insert into opciones values ('A1','TP', 'A', 'Consultar') 
		insert into opciones values ('A2','TP', 'A', 'Solicitar Vacaciones') 		
		insert into opciones values ('B1','TP', 'B', 'Ausentismo') 
		insert into opciones values ('C1','TP', 'C', 'Recibos') 
		insert into opciones values ('R1','TP', 'R', 'Imprimir Reportes') 
		insert into opciones values ('E1','TP', 'E', 'Tiempo Extra') 
		insert into opciones values ('F1','TP', 'F', 'Datos Personales') 
		insert into opciones values ('G1','TP', 'G', 'Datos Nmina') 	
		
		update opciones  set descripcion='Imprimir Reportes' where opcion='R1' and funcion='R' and sistema='TP'
		update funciones set descripcion='Imprimir Reportes' where funcion='R' and sistema='TP'
		update funciones set descripcion='Vacaciones' where funcion='A' and sistema='TP'	
   
	END
		
	if (@EXISTE=1 and @existe2=0)
	BEGIN
		insert into funciones values ('TP', 'B' , 'Ausentismo') 
		insert into funciones values ('TP', 'C' , 'Recibos') 		
		insert into funciones values ('TP', 'E' , 'Tiempo Extra') 
		insert into funciones values ('TP', 'F' , 'Datos Personales') 
		insert into funciones values ('TP', 'G' , 'Datos Nmina') 
		
		insert into opciones values ('A2','TP', 'A', 'Solicitar Vacaciones') 		
		insert into opciones values ('B1','TP', 'B', 'Ausentismo') 
		insert into opciones values ('C1','TP', 'C', 'Recibos') 		
		insert into opciones values ('E1','TP', 'E', 'Tiempo Extra') 
		insert into opciones values ('F1','TP', 'F', 'Datos Personales') 
		insert into opciones values ('G1','TP', 'G', 'Datos Nmina') 
				
		update opciones set descripcion='Imprimir Reportes' where opcion='R1' and funcion='R' and sistema='TP'
		update funciones set descripcion='Imprimir Reportes' where funcion='R' and sistema='TP'
		update funciones set descripcion='Vacaciones' where funcion='A' and sistema='TP'		 
   
	END
	
	if @existe3=0
		begin
				   
		INSERT INTO perfiles
			   (descripcion
			   ,sistema
			   ,empresas
			   ,nomina
			   ,actualizar
			   ,sueldo
			   ,PortalEmp)
		 VALUES
			   ('Admin. Portal del Trabajador'	
			   ,'TP'
			   ,'{}'
			   ,'{}'
			   ,'N'
			   ,'N'
			   ,null)					   			   					  					   
			
			select @IDPERFIL=ISNULL(idperfil ,0)
			from perfiles
			where descripcion='Admin. Portal del Trabajador'	
			
			insert into perfil_funcion 
					   Select opciones.Funcion,opciones.Opcion, @IDPERFIL
					   From Opciones 
					   Where opciones.sistema = 'TP' 		
			
			Insert into perfil_usuarios values (@IDPERFIL, 'Administrador')
			end
	
	return @existe
   
 GO
 
 EXEC DBO.peCargaFunciones
 GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peSolicitudVacaciones'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.peSolicitudVacaciones
GO
CREATE PROCEDURE [dbo].peSolicitudVacaciones
	(	@empresa bigint,
		@codigo bigint		
    )
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
   
     SELECT
			empresas.registro_patronal,
			empresas.rfc_empresa,
			empresas.nombre_empresa,
			empresas.direccion_empresa,
			empresas.colonia_empresa,
			empresas.poblacion_empresa,
			empresas.telefono_empresa,
			empleados.empresa,
			empleados.codigo,
			RTRIM(ISNULL(empleados.nombre,'')) + ' ' + RTRIM(ISNULL(empleados.ap_paterno,'')) + ' ' + RTRIM(ISNULL(empleados.ap_materno,'')) AS nombre,
			empleados.ap_paterno,
			empleados.ap_materno,
			empleados.fchalta,
			tabulador.actividad,
			centros.centro,
			centros.nomdepto
		FROM
			empresas empresas 
			inner join Llaves Llaves ON
				empresas.empresa = Llaves.empresa
			INNER JOIN empleados empleados ON
				Llaves.empresa = empleados.empresa AND
				Llaves.codigo = empleados.codigo
			INNER JOIN tabulador tabulador ON
				Llaves.empresa = tabulador.empresa AND
				Llaves.ocupacion = tabulador.ocupacion
			INNER JOIN centros centros ON
				Llaves.centro = centros.centro AND
				Llaves.empresa = centros.empresa
		WHERE
			empleados.empresa = @empresa AND
			empleados.codigo = @codigo               
GO  
 
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peInformacionGeneral'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.peInformacionGeneral
GO
CREATE PROCEDURE [dbo].peInformacionGeneral
	(	@empresa bigint ,
		@codigo bigint 
	)	
    
AS 
    SET NOCOUNT ON
    
    declare @padre as varchar(250)
    declare @madre as varchar(250)
    declare @conyuge as varchar(250)
    
	select @padre=p.nombre, @madre=m.nombre, @conyuge=e.nombre 
	 from rhcatalogo c, rhfamiliar p, rhfamiliar m, rhfamiliar e  
	 where c.codigo= @codigo
	 and c.empresa= @empresa
	 and c.idcatalogo = p.idcatalogo 
	 and c.idcatalogo = m.idcatalogo 
	 and c.idcatalogo = e.idcatalogo 
	 and p.idparentesco = 1 
	 and m.idparentesco = 2 
	  and e.idparentesco = 5 
    
    SELECT   
    isnull(empleados.codigo,0) as codigo,
    rtrim(isnull(empleados.nombre,'')) + ' ' + 
    rtrim(isnull(empleados.ap_paterno,'')) + ' ' + 
    rtrim(isnull(empleados.ap_materno,'')) as trabajador,
    isnull(empleados.afiliacion,'') as afiliacion,
    isnull(empleados.digvera,'') as digvera,
    isnull(empleados.curp,'') as curp,
    isnull(empleados.fchantigua,'') as fchantigua,
    isnull(empleados.fchalta,'') as fchalta,
    case empleados.tiposal
		when 1 then '1 - Fijo'
		when 2 then '2 - Variable'
		when 3 then '3 - Destajo' end as tiposal,
    case empleados.tipo_emp
		when 1 then '1 - Ordinario'
		when 2 then '2 - EVENTUAL'
		when 3 then '3 - IND. CONST.' end  as tipo_emp,
    isnull(empleados.cta_bco_no,'') as cta_bco_no,
    rtrim(isnull(empleados.rfcalfa,'')) + 
    rtrim(isnull(empleados.rfcnum,''))+ '-' + 
    rtrim(isnull(empleados.rfchomo,'')) as rfc,
    isnull(empleados.fchnac,'') as fchnac,
    isnull(empleados.edonac,'') as edonac, 
    isnull(datosemps.domicilio,'')as domicilio,
    isnull(datosemps.colonia,'') as colonia,
    isnull(datosemps.poblacion,'') as poblacion,
    isnull(datosemps.codpostal,0) as codpostal,
    case rtrim(datosemps.edocivil)
		when 'C' then 'Casado'
		when 'S' then 'Soltero'
		when 'D' then 'Divorciado'
		when 'V' then 'Viudo'
		when 'U' then 'Union Libre'
		else 'Otro' end as edocivil,
    isnull(datosemps.telefono,'') as telefono,
    isnull(datosemps.nacional,'') as nacional,
    isnull(datosemps.email,'') as email,
    case Llaves.tiponom 
		when 1 then 'Decenal'
		when 2 then 'Semanal'
		when 3 then 'Catorcenal'
		when 4 then 'Quincenal'
		when 5 then 'Mensual'
		when 6 then 'Especial'
		end as  tiponom,
    isnull(centros.centro,'') as centro,
    isnull(centros.nomdepto,'') as nomdepto,
    isnull(horarios_catalogo.horario,'')as horario,
    isnull(horarios_catalogo.nombre,'') as nombrecatalogo,
    isnull(bancos.nombre,'') as nombrebanco,
    isnull(tabulador.actividad,'') as actividad,
    isnull(Nominas.nomina,'') as nomina,
    isnull(@padre,'') as padre,
    isnull(@madre,'') as madre,
    DATEDIFF(yy,empleados.fchnac,GETDATE()) as edad,
    isnull(@conyuge,'') as conyuge,
    isnull(datosemps.municipio,'') as municipios,
    isnull(datosemps.localidad,'') as localidad
    
FROM
    empresas empresas 
    INNER JOIN empleados empleados ON
        empresas.empresa = empleados.empresa
    INNER JOIN datosemps datosemps ON
        empleados.empresa = datosemps.empresa AND
        empleados.codigo = datosemps.codigo
    INNER JOIN Llaves Llaves ON
        empleados.empresa = Llaves.empresa AND
        empleados.codigo = Llaves.codigo
    INNER JOIN centros centros ON
        Llaves.centro = centros.centro AND
        Llaves.empresa = centros.empresa
    INNER JOIN horarios_catalogo horarios_catalogo ON
        Llaves.empresa = horarios_catalogo.empresa AND
        Llaves.horario = horarios_catalogo.horario
    INNER JOIN bancos bancos ON
        Llaves.banco = bancos.banco
    INNER JOIN tabulador tabulador ON
        Llaves.empresa = tabulador.empresa AND
        Llaves.ocupacion = tabulador.ocupacion
    LEFT OUTER JOIN Nominas Nominas ON
        Llaves.empresa = Nominas.empresa AND
        Llaves.tiponom = Nominas.tiponom
WHERE
    empresas.empresa = @empresa AND
    empleados.codigo = @codigo
   
GO  
  
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peCursosPorTrabajador'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.peCursosPorTrabajador
GO
CREATE PROCEDURE [dbo].peCursosPorTrabajador
	(	@empresa bigint ,
		@codigo bigint
		
    )
AS 
    SET NOCOUNT ON
    
    SELECT
    isnull(empleados.codigo,0) as codigo,
    rtrim(isnull(empleados.nombre,'')) + ' ' + 
    rtrim(isnull(empleados.ap_paterno,'')) + ' ' + 
    rtrim(isnull(empleados.ap_materno,'')) as trabajador,
    isnull(capa_Programacion.idProgramacion,0) as idprogramacion ,
    isnull(capa_Programacion.finicial,'') as finicial,
    isnull(capa_Programacion.ffinal,'') as ffinal,
    isnull(capa_Programacion.tothoras,'') as tothoras,
    isnull(capa_Instructor.nombre,'') as nombreinstructor,
    isnull(capa_Curso.clave,'') as clavecurso,
    isnull(capa_Curso.nombre,'') as nombrecurso
FROM
    empresas empresas 
    INNER JOIN empleados empleados ON
        empresas.empresa = empleados.empresa
    INNER JOIN capa_EmpleadoProgramacion capa_EmpleadoProgramacion ON
        empleados.empresa = capa_EmpleadoProgramacion.empresa AND
        empleados.codigo = capa_EmpleadoProgramacion.codigo
    INNER JOIN capa_Programacion capa_Programacion ON
        capa_EmpleadoProgramacion.empresa = capa_Programacion.empresa AND
        capa_EmpleadoProgramacion.idProgramacion = capa_Programacion.idProgramacion
    INNER JOIN capa_Instructor capa_Instructor ON
        capa_Programacion.empresa = capa_Instructor.empresa AND
        capa_Programacion.idInstructor = capa_Instructor.idInstructor
    INNER JOIN Capa_curso capa_Curso ON
        capa_Programacion.empresa = capa_Curso.empresa AND
        capa_Programacion.idCurso = capa_Curso.idcurso
	WHERE
		empleados.empresa = @empresa AND
		empleados.codigo = @codigo
    
GO	

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peConstanciaTrabajo'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.peConstanciaTrabajo
GO
CREATE PROCEDURE [dbo].peConstanciaTrabajo
	(	@empresa bigint,
		@codigo bigint
	)
    
AS 
    SET NOCOUNT ON
    
    SELECT    
    Llaves.centro,
    centros.nomdepto,
    tabulador.actividad,
    empleados.empresa,
    empleados.codigo,
    rtrim(isnull(empleados.nombre,'')) + ' ' + 
    rtrim(isnull(empleados.ap_paterno,'')) + ' ' + 
    rtrim(isnull(empleados.ap_materno,'')) as trabajador,
    empleados.afiliacion,
    empleados.digvera,
    empleados.curp,
    empleados.fchalta,
    empleados.sueldo,
    rtrim(isnull(empleados.rfcalfa,'')) + 
    rtrim(isnull(empleados.rfcnum,''))+ '-' + 
    rtrim(isnull(empleados.rfchomo,'')) as rfc
	FROM
    empresas empresas 
    INNER JOIN Llaves Llaves ON
        empresas.empresa = Llaves.empresa
    INNER JOIN centros centros ON
        Llaves.centro = centros.centro AND
        Llaves.empresa = centros.empresa
    INNER JOIN tabulador tabulador ON
        Llaves.empresa = tabulador.empresa AND
        Llaves.ocupacion = tabulador.ocupacion
    INNER JOIN empleados empleados ON
        Llaves.empresa = empleados.empresa AND
        Llaves.codigo = empleados.codigo
	WHERE
		empleados.empresa = @empresa AND
		empleados.codigo = @codigo
    
GO    

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peConstanciaVacaciones'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.peConstanciaVacaciones
GO
CREATE PROCEDURE [dbo].peConstanciaVacaciones
	(	@empresa bigint ,
		@codigo bigint )		
    
AS 
    SET NOCOUNT ON
    
    SELECT   
		empleados.empresa,
		empleados.codigo,
		rtrim(isnull(empleados.nombre,'')) + ' ' + 
		rtrim(isnull(empleados.ap_paterno,'')) + ' ' + 
		rtrim(isnull(empleados.ap_materno,'')) as trabajador,
		empleados.fchalta,
		tabulador.actividad,
		centros.centro,
		centros.nomdepto
	FROM
		empresas empresas 
		INNER JOIN Llaves Llaves ON
			empresas.empresa = Llaves.empresa
		INNER JOIN empleados empleados ON
			Llaves.empresa = empleados.empresa AND
			Llaves.codigo = empleados.codigo
		INNER JOIN tabulador tabulador ON
			Llaves.empresa = tabulador.empresa AND
			Llaves.ocupacion = tabulador.ocupacion
		INNER JOIN centros centros ON
			Llaves.centro = centros.centro AND
			Llaves.empresa = centros.empresa
	WHERE
		empleados.codigo = @CODIGO AND
		empleados.empresa = @EMPRESA
    
GO    

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peConstanciaAntiguedad'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.peConstanciaAntiguedad
GO
CREATE PROCEDURE [dbo].peConstanciaAntiguedad
	(	@empresa bigint ,
		@codigo bigint )		
    
AS 
    SET NOCOUNT ON

	SELECT
		empleados.empresa,
		empleados.codigo,
		rtrim(isnull(empleados.nombre,'')) + ' ' + 
		rtrim(isnull(empleados.ap_paterno,'')) + ' ' + 
		rtrim(isnull(empleados.ap_materno,'')) as trabajador,
		empleados.fchalta,
		vacaciones.dias_tab,
		datediff(d,empleados.fchalta,GETDATE())/365 as antiguedad
	FROM
		empresas empresas 
		INNER JOIN empleados empleados ON
			empresas.empresa = empleados.empresa
		INNER JOIN vacaciones vacaciones ON
			empleados.codigo = vacaciones.codigo AND
			empleados.empresa = vacaciones.empresa
	WHERE
		empleados.empresa = @empresa
		and empleados.codigo=@codigo
		
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'pePrestamoInfonavit'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.pePrestamoInfonavit
GO
CREATE PROCEDURE [dbo].pePrestamoInfonavit
	(	@empresa bigint ,
		@codigo bigint )		
    
AS 
    SET NOCOUNT ON

	SELECT
		rtrim(isnull(empleados.nombre,'')) + ' ' + 
		rtrim(isnull(empleados.ap_paterno,'')) + ' ' + 
		rtrim(isnull(empleados.ap_materno,'')) as trabajador,
		infonavit.codigo,
		infonavit.tipo_cred,
		infonavit.numcredito,
		infonavit.descuento,
		infonavit.amortizacion_cedula,
		infonavit.amortizacion_retenido,
		infonavit.amortizacion_sigmes,
		infonavit.fecha,
		infonavit.fch_otorga,
		infonavit.fch_termino
	FROM
		empresas empresas 
		INNER JOIN empleados empleados ON
			empresas.empresa = empleados.empresa
		INNER JOIN infonavit infonavit ON
			empleados.empresa = infonavit.empresa AND
			empleados.codigo = infonavit.codigo
	WHERE
		infonavit.codigo = @codigo AND
		infonavit.empresa = @empresa
    
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peValidaEntrada'
                    AND type = 'P' ) 
                    
    DROP PROCEDURE dbo.peValidaEntrada    
GO

CREATE PROCEDURE dbo.peValidaEntrada
	(
      @employeeId bigint ,  
      @employeePassword AS varchar(250) ,
      @startPosition AS udtInteger ,
      @elementsToRetrieve AS udtInteger
    ) 
    
    WITH ENCRYPTION
AS 

	begin
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @selectClause AS NVARCHAR(4000)
    DECLARE @whereClause AS udtStringSize2048
    DECLARE @orderByClause AS udtStringSize1024
    DECLARE @totalRecords AS udtInteger 
    DECLARE @startPositionPlusOneElement AS udtInteger
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debugFlag AS udtBoolean
    SET XACT_ABORT ON
    
  DECLARE @decryptedPassword varchar(250)
  SET @decryptedPassword = (SELECT dbo.employyedecrypPassword(@employeePassword))
        DECLARE @totReg AS TABLE
            (
              empresa bigint ,
              regpat varchar(250) ,
              codigo bigint ,
              referencia varchar(250) ,
              password_empleado varchar(250) ,
              rfc varchar(250) ,
              passw varchar(250),
              nombre varchar(200),
              email varchar(100)
            )
  
        INSERT  INTO @totReg
                ( empresa ,
                  regpat ,
                  codigo ,
                  referencia ,
                  password_empleado ,
                  rfc ,
                  passw,
                  nombre,
                  email
                )
                SELECT  a.empresa ,
                        a.registro_patronal ,
                        b.codigo ,
                        CASE WHEN LEN(a.referencia) = 0
                                  OR a.referencia IS NULL
                             THEN a.nombre_empresa
                             ELSE a.referencia
                        END AS referencia ,
                        CASE WHEN b.password_empleado IS NULL
                                  OR LEN(b.password_empleado) <= 0
                             THEN b.rfcAlfa + b.rfcnum + b.rfchomo
                             ELSE b.password_empleado
                        END AS password_empleado ,
                        b.rfcAlfa + b.rfcnum + b.rfchomo,
                        CASE WHEN b.password_empleado IS NULL
                                  OR LEN(b.password_empleado) <= 0 THEN 'A'
                             ELSE 'P'
                        END AS passw,
                        RTRIM(b.ap_paterno) + ' ' + RTRIM(b.ap_materno) + ' ' + RTRIM(b.nombre) AS nombre,
                        isnull(datosemps.email,'')
                FROM    empresas AS a
                        INNER JOIN empleados AS b ON b.empresa = a.empresa
                        INNER JOIN datosemps  ON b.empresa = datosemps.empresa
								and datosemps.codigo=b.codigo
                        inner join perfil_empleado on b.codigo=perfil_empleado.codigo
									and b.empresa= perfil_empleado.empresa
                WHERE   b.codigo = @employeeId
						AND b.activo='S'
						and b.empresa=perfil_empleado.empresa
                ORDER BY a.empresa ASC
       
                
                
    SELECT *
    FROM @totReg
    WHERE codigo = @employeeId 
    AND (CASE WHEN passw = 'A' THEN rfc END = @decryptedPassword
    OR CASE WHEN passw = 'P' THEN password_empleado END = @employeePassword)
   
   end

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peBuscaEmpresas'
                    AND type = 'P' ) 
                    
    DROP PROCEDURE dbo.peBuscaEmpresas
    
GO

CREATE PROCEDURE [dbo].peBuscaEmpresas
   
AS 
    SET NOCOUNT ON

	select empresa,nombre_empresa,registro_patronal,rfc_empresa,referencia from empresas
				
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'peValidaPasswordNulo'
                    AND type = 'P' ) 
                    
    DROP PROCEDURE dbo.peValidaPasswordNulo
    
GO

CREATE PROCEDURE [dbo].peValidaPasswordNulo
	(	@codigo bigint,
	    @empresa bigint)		
    
AS 
    SET NOCOUNT ON
    
	select isnull(password_empleado,'') 
	from empleados
    where codigo=@codigo
	and empresa=@empresa
    and activo='S'
     
GO

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'pePortalPatronObtenListadoRecibos' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.pePortalPatronObtenListadoRecibos
GO

CREATE PROCEDURE dbo.pePortalPatronObtenListadoRecibos
(
	@tiponom udtInteger,
	@ao udtInteger,
	@periodoI udtInteger,
	@periodoF udtInteger,
	@agi udtName,
	@fdo udtName,
	@otr udtName,
	@llave bigint,
	@codigo bigint	,
	@afiliacion varchar(15),
	@company bigint
)
	with ENCRYPTION
	
AS
	SET NOCOUNT ON 

	declare @empresa as bigint
	select @empresa=empresa
	from tmpAccesoPortalPatron
	where llave=@llave

	IF OBJECT_ID(N'dbo.#Historial', N'U') IS NOT NULL  
    begin
		DROP TABLE [dbo].[#Historial]  
	end

	CREATE TABLE #Historial (empresa bigint, codigo bigint)
	INSERT INTO #Historial (empresa,codigo)
	SELECT empresa,codigo from dbo.PortalEmpleado_EmpleadoConsolidar(@empresa,@codigo)
	
/*DECLARE @company udtInteger

SET @company = CASE WHEN ISNULL((SELECT emps_todas FROM dbo.PortalEmpleadoConfig WHERE llave=1),'N') = 'S' THEN 0 ELSE @companyId END	*/
	
DECLARE @kardex TABLE (nomina udtName,periodo udtInteger,codigo udtInteger,nombre udtName,inicio udtName,cierre udtName, dias udtNumeric10_2,sueldo udtNumeric10_2,percepciones udtNumeric10_2,deducciones udtNumeric10_2,isr udtNumeric10_2,imss udtNumeric10_2, neto udtNumeric10_2, mail udtName, tipo udtInteger, empresa udtInteger, tiponom udtname, nombretipo udtname)

INSERT INTO @kardex
        ( nomina ,
          periodo ,
          codigo ,
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          tipo,
          empresa, 
          tiponom,
          nombretipo
        )
SELECT nomina,periodo,codigo,nombre,inicio,cierre,dias,sueldo,percepciones,deducciones,isr,imss,percepciones-deducciones AS neto,mail,3 AS tipo,empresa, tiponom, nombretipo
FROM(
		SELECT	k.nomina,
				k.periodo,
				k.codigo,
				ISNULL(de.email,'') AS mail,
				RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS nombre,
				CONVERT(NVARCHAR(30),p.inicio,103) AS inicio,
				CONVERT(NVARCHAR(30),p.cierre,103) AS cierre,
				p.dias,
				SUM(CASE WHEN k.num_conc<=7 THEN k.importe ELSE 0 end) AS sueldo,
				SUM(CASE WHEN k.num_conc>=1 AND k.num_conc<=99 THEN k.importe ELSE 0 end) AS percepciones,
				SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=199 THEN k.importe ELSE 0 end) AS deducciones,
				SUM(CASE WHEN k.num_conc=136 THEN k.importe ELSE 0 end) AS isr,
				SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=106 THEN k.importe ELSE 0 end) AS imss,
				k.empresa, 
				(case  
					when  k.tiponom=1 then 'Semanal'
					when  k.tiponom=2 then 'Decenal'
					when  k.tiponom=3 then 'Catorcenal'
					when  k.tiponom=4 then 'Quincenal'
					when  k.tiponom=5 then 'Mensual'
					when  k.tiponom=6 then 'Especial'
				end) as tiponom, isnull(n.nomina,'') as nombreTipo 
		FROM dbo.kardex_anual AS k 
		left JOIN dbo.empleados AS e ON k.empresa = e.empresa AND k.codigo = e.codigo
		left JOIN dbo.datosemps AS de ON e.empresa = de.empresa AND e.codigo = de.codigo
		left JOIN dbo.Periodos AS p ON k.tiponom = p.tiponom AND k.periodo = p.periodo AND k.ayo_operacion = p.ayo_operacion AND k.empresa = p.empresa
		left join #Historial h on h.empresa=k.empresa and h.codigo=k.codigo
		left join dbo.Nominas as n on k.empresa = n.empresa and n.tiponom=k.tiponom
		WHERE	k.ayo_operacion=@ao
				AND (k.periodo>=@periodoI AND k.periodo<=@periodoF)
				AND k.nomina='ORD'
				and k.codigo=@codigo
		GROUP BY k.nomina,
				k.periodo,
				k.codigo,
				de.email,
				RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre),
				p.inicio,
				p.cierre,
				p.dias,
				k.empresa,
				k.tiponom,
				n.nomina
) AS kardexTable
ORDER BY codigo,tiponom DESC,periodo DESC


IF @agi <>''
BEGIN 
	delete from @kardex 
	
	INSERT INTO @kardex
        ( nomina ,
          periodo ,
          codigo ,
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          tipo ,
          empresa, 
          tiponom,
          nombretipo
        )
	SELECT nomina,periodo,codigo,nombre,inicio,cierre,dias,sueldo,percepciones,deducciones,isr,imss,percepciones-deducciones AS neto,mail,1 AS tipo,empresa, tiponom, nombretipo
	FROM(
			SELECT	k.nomina,
					k.periodo,
					k.codigo,
					de.email AS mail,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS nombre,
					CONVERT(NVARCHAR(30),p.inicio,103) AS inicio,
					CONVERT(NVARCHAR(30),p.cierre,103) AS cierre,
					p.dias,
					SUM(CASE WHEN k.num_conc<=7 THEN k.importe ELSE 0 end) AS sueldo,
					SUM(CASE WHEN k.num_conc>=1 AND k.num_conc<=99 THEN k.importe ELSE 0 end) AS percepciones,
					SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=199 THEN k.importe ELSE 0 end) AS deducciones,
					SUM(CASE WHEN k.num_conc=136 THEN k.importe ELSE 0 end) AS isr,
					SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=106 THEN k.importe ELSE 0 end) AS imss,
					k.empresa,
					(case  
					when  k.tiponom=1 then 'Semanal'
					when  k.tiponom=2 then 'Decenal'
					when  k.tiponom=3 then 'Catorcenal'
					when  k.tiponom=4 then 'Quincenal'
					when  k.tiponom=5 then 'Mensual'
					when  k.tiponom=6 then 'Especial'
				end) as tiponom, isnull(n.nomina,'') as nombreTipo 
			FROM dbo.kardex_anual AS k 
			INNER JOIN dbo.empleados AS e ON k.empresa = e.empresa AND k.codigo = e.codigo
			INNER JOIN dbo.datosemps AS de ON e.empresa = de.empresa AND e.codigo = de.codigo
			INNER JOIN dbo.Periodos AS p ON k.tiponom = p.tiponom AND k.periodo = p.periodo AND k.ayo_operacion = p.ayo_operacion AND k.empresa = p.empresa
		    left join #Historial h on h.empresa=k.empresa and h.codigo=k.codigo
			inner join dbo.Nominas as n on k.empresa = n.empresa and n.tiponom=k.tiponom
			WHERE	 k.ayo_operacion=@ao
					AND k.nomina='AGI'
					and k.codigo=@codigo
			GROUP BY k.nomina,
					k.periodo,
					k.codigo,
					de.email,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre),
					p.inicio,
					p.cierre,
					p.dias,
					k.empresa,
					k.tiponom,
					n.nomina
	) AS kardexTable
	ORDER BY codigo
END 

IF @otr <>''
BEGIN 
	delete from @kardex 
	
	INSERT INTO @kardex
        ( nomina ,
          periodo ,
          codigo ,
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          tipo ,
          empresa, 
          tiponom, 
          nombretipo
        )
	SELECT nomina,periodo,codigo,nombre,inicio,cierre,dias,sueldo,percepciones,deducciones,isr,imss,percepciones-deducciones AS neto,mail,4 AS tipo,empresa, tiponom, nombreTipo
	FROM(
			SELECT	k.nomina,
					k.periodo,
					k.codigo,
					de.email AS mail,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS nombre,
					CONVERT(NVARCHAR(30),p.inicio,103) AS inicio,
					CONVERT(NVARCHAR(30),p.cierre,103) AS cierre,
					p.dias,
					SUM(CASE WHEN k.num_conc<=7 THEN k.importe ELSE 0 end) AS sueldo,
					SUM(CASE WHEN k.num_conc>=1 AND k.num_conc<=99 THEN k.importe ELSE 0 end) AS percepciones,
					SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=199 THEN k.importe ELSE 0 end) AS deducciones,
					SUM(CASE WHEN k.num_conc=136 THEN k.importe ELSE 0 end) AS isr,
					SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=106 THEN k.importe ELSE 0 end) AS imss,
					k.empresa,
					(case  
					when  k.tiponom=1 then 'Semanal'
					when  k.tiponom=2 then 'Decenal'
					when  k.tiponom=3 then 'Catorcenal'
					when  k.tiponom=4 then 'Quincenal'
					when  k.tiponom=5 then 'Mensual'
					when  k.tiponom=6 then 'Especial'
				end) as tiponom, isnull(n.nomina,'') as nombreTipo 
			FROM dbo.kardex_anual AS k 
			INNER JOIN dbo.empleados AS e ON k.empresa = e.empresa AND k.codigo = e.codigo
			INNER JOIN dbo.datosemps AS de ON e.empresa = de.empresa AND e.codigo = de.codigo
			INNER JOIN dbo.Periodos AS p ON k.tiponom = p.tiponom AND k.periodo = p.periodo AND k.ayo_operacion = p.ayo_operacion AND k.empresa = p.empresa
			left join #Historial h on h.empresa=k.empresa and h.codigo=k.codigo
			inner join dbo.Nominas as n on k.empresa = n.empresa and n.tiponom=k.tiponom
			WHERE	k.ayo_operacion=@ao
					AND (k.periodo>=@periodoI AND k.periodo<=@periodoF)
					AND k.nomina='OTR'
					and k.codigo=@codigo
			GROUP BY k.nomina,
					k.periodo,
					k.codigo,
					de.email,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre),
					p.inicio,
					p.cierre,
					p.dias,
					k.empresa,
					k.tiponom,
					n.nomina
	) AS kardexTable
	ORDER BY codigo
END 

IF @fdo <>''
BEGIN 
	delete from @kardex 
	
	INSERT INTO @kardex
        ( nomina ,
          periodo ,
          codigo ,
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          tipo ,
          empresa,
          tiponom,
          nombretipo
        )
	SELECT nomina,periodo,codigo,nombre,inicio,cierre,dias,sueldo,percepciones,deducciones,isr,imss,percepciones-deducciones AS neto,mail,2 AS tipo,empresa,tiponom, nombretipo
	FROM(
			SELECT	'FDO' AS nomina,
					0 AS periodo,
					k.codigo,
					de.email AS mail,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS nombre,
					'  /  /    ' AS inicio,
					'  /  /    ' AS cierre,
					k.dias,
					0 AS sueldo,
					k.importe_p + k.importe_t + k.intereses AS percepciones,
					k.retiros + k.adeudo AS deducciones,
					0 AS isr,
					0 AS imss,
					k.empresa,
					(case  
					when  l.tiponom=1 then 'Semanal'
					when  l.tiponom=2 then 'Decenal'
					when  l.tiponom=3 then 'Catorcenal'
					when  l.tiponom=4 then 'Quincenal'
					when  l.tiponom=5 then 'Mensual'
					when  l.tiponom=6 then 'Especial'
				end) as tiponom ,'' as nombretipo
			FROM dbo.fondo_de_ahorros_anual AS k 
			INNER JOIN dbo.empleados AS e ON k.empresa = e.empresa AND k.codigo = e.codigo
			INNER JOIN dbo.datosemps AS de ON e.empresa = de.empresa AND e.codigo = de.codigo
			INNER JOIN dbo.Llaves AS l ON e.empresa = l.empresa AND e.codigo = l.codigo
			left join #Historial h on h.empresa=k.empresa and h.codigo=k.codigo
			INNER JOIN dbo.tmpAccesoPortalPatron AS tmp ON k.empresa = tmp.empresa AND tmp.llave=@llave
			WHERE	k.ejercicio=@ao
					and k.codigo=@codigo
					and rtrim(e.rfcalfa) + rtrim(e.rfcnum) + rtrim(e.rfchomo) = @afiliacion
	) AS kardexTable
	ORDER BY codigo
END 



SELECT nomina ,
          periodo ,
          codigo ,
          tiponom,
          (case when nombretipo='' then tiponom else nombretipo end),
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          empresa
FROM @kardex
ORDER BY tipo,CAST(SUBSTRING(inicio,7,4)+SUBSTRING(inicio,4,2)+SUBSTRING(inicio,1,2) AS datetime) DESC



GO

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'pePortalPatronObtenListadoRecibosActivos' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.pePortalPatronObtenListadoRecibosActivos
GO

CREATE PROCEDURE dbo.pePortalPatronObtenListadoRecibosActivos
(
	@tiponom udtInteger,
	@ao udtInteger,
	@periodoI udtInteger,
	@periodoF udtInteger,
	@agi udtName,
	@fdo udtName,
	@otr udtName,
	@llave bigint,
	@codigo bigint	,
	@afiliacion varchar(15),
	@company	bigint
)
	with ENCRYPTION
	
AS
	SET NOCOUNT ON 
	
/*DECLARE @company udtInteger

SET @company = CASE WHEN ISNULL((SELECT emps_todas FROM dbo.PortalEmpleadoConfig WHERE llave=1),'N') = 'S' THEN 0 ELSE @companyId END	*/
	
DECLARE @kardex TABLE (nomina udtName,periodo udtInteger,codigo udtInteger,nombre udtName,inicio udtName,cierre udtName, dias udtNumeric10_2,sueldo udtNumeric10_2,percepciones udtNumeric10_2,deducciones udtNumeric10_2,isr udtNumeric10_2,imss udtNumeric10_2, neto udtNumeric10_2, mail udtName, tipo udtInteger, empresa udtInteger, tiponom udtname, nombretipo udtname)

INSERT INTO @kardex
        ( nomina ,
          periodo ,
          codigo ,
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          tipo,
          empresa, 
          tiponom,
          nombretipo
        )
SELECT nomina,periodo,codigo,nombre,inicio,cierre,dias,sueldo,percepciones,deducciones,isr,imss,percepciones-deducciones AS neto,mail,3 AS tipo,empresa, tiponom, nombretipo
FROM(
		SELECT	k.nomina,
				k.periodo,
				k.codigo,
				ISNULL(de.email,'') AS mail,
				RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS nombre,
				CONVERT(NVARCHAR(30),p.inicio,103) AS inicio,
				CONVERT(NVARCHAR(30),p.cierre,103) AS cierre,
				p.dias,
				SUM(CASE WHEN k.num_conc<=7 THEN k.importe ELSE 0 end) AS sueldo,
				SUM(CASE WHEN k.num_conc>=1 AND k.num_conc<=99 THEN k.importe ELSE 0 end) AS percepciones,
				SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=199 THEN k.importe ELSE 0 end) AS deducciones,
				SUM(CASE WHEN k.num_conc=136 THEN k.importe ELSE 0 end) AS isr,
				SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=106 THEN k.importe ELSE 0 end) AS imss,
				k.empresa, 
				(case  
					when  k.tiponom=1 then 'Semanal'
					when  k.tiponom=2 then 'Decenal'
					when  k.tiponom=3 then 'Catorcenal'
					when  k.tiponom=4 then 'Quincenal'
					when  k.tiponom=5 then 'Mensual'
					when  k.tiponom=6 then 'Especial'
				end) as tiponom, isnull(n.nomina,'') as nombreTipo 
		FROM dbo.kardex_anual AS k 
		INNER JOIN dbo.empleados AS e ON k.empresa = e.empresa AND k.codigo = e.codigo
		INNER JOIN dbo.datosemps AS de ON e.empresa = de.empresa AND e.codigo = de.codigo
		INNER JOIN dbo.Periodos AS p ON k.tiponom = p.tiponom AND k.periodo = p.periodo AND k.ayo_operacion = p.ayo_operacion AND k.empresa = p.empresa
		INNER JOIN dbo.tmpAccesoPortalPatron AS tmp ON k.empresa = tmp.empresa AND tmp.llave=@llave
		inner join dbo.Nominas as n on k.empresa = n.empresa and n.tiponom=k.tiponom
		WHERE	k.ayo_operacion=@ao
				AND (k.periodo>=@periodoI AND k.periodo<=@periodoF)
				AND k.nomina='ORD'
				and k.codigo=@codigo
				and k.empresa=@company
		GROUP BY k.nomina,
				k.periodo,
				k.codigo,
				de.email,
				RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre),
				p.inicio,
				p.cierre,
				p.dias,
				k.empresa,
				k.tiponom,
				n.nomina
) AS kardexTable
ORDER BY codigo,tiponom DESC,periodo DESC


IF @agi <>''
BEGIN 
	INSERT INTO @kardex
        ( nomina ,
          periodo ,
          codigo ,
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          tipo ,
          empresa, 
          tiponom,
          nombretipo
        )
	SELECT nomina,periodo,codigo,nombre,inicio,cierre,dias,sueldo,percepciones,deducciones,isr,imss,percepciones-deducciones AS neto,mail,1 AS tipo,empresa, tiponom, nombretipo
	FROM(
			SELECT	k.nomina,
					k.periodo,
					k.codigo,
					de.email AS mail,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS nombre,
					CONVERT(NVARCHAR(30),p.inicio,103) AS inicio,
					CONVERT(NVARCHAR(30),p.cierre,103) AS cierre,
					p.dias,
					SUM(CASE WHEN k.num_conc<=7 THEN k.importe ELSE 0 end) AS sueldo,
					SUM(CASE WHEN k.num_conc>=1 AND k.num_conc<=99 THEN k.importe ELSE 0 end) AS percepciones,
					SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=199 THEN k.importe ELSE 0 end) AS deducciones,
					SUM(CASE WHEN k.num_conc=136 THEN k.importe ELSE 0 end) AS isr,
					SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=106 THEN k.importe ELSE 0 end) AS imss,
					k.empresa,
					(case  
					when  k.tiponom=1 then 'Semanal'
					when  k.tiponom=2 then 'Decenal'
					when  k.tiponom=3 then 'Catorcenal'
					when  k.tiponom=4 then 'Quincenal'
					when  k.tiponom=5 then 'Mensual'
					when  k.tiponom=6 then 'Especial'
				end) as tiponom, isnull(n.nomina,'') as nombreTipo 
			FROM dbo.kardex_anual AS k 
			INNER JOIN dbo.empleados AS e ON k.empresa = e.empresa AND k.codigo = e.codigo
			INNER JOIN dbo.datosemps AS de ON e.empresa = de.empresa AND e.codigo = de.codigo
			INNER JOIN dbo.Periodos AS p ON k.tiponom = p.tiponom AND k.periodo = p.periodo AND k.ayo_operacion = p.ayo_operacion AND k.empresa = p.empresa
			INNER JOIN dbo.tmpAccesoPortalPatron AS tmp ON k.empresa = tmp.empresa AND tmp.llave=@llave
			inner join dbo.Nominas as n on k.empresa = n.empresa and n.tiponom=k.tiponom
			WHERE	 k.ayo_operacion=@ao
					AND k.nomina='AGI'
					and k.codigo=@codigo
					and k.empresa=@company
			GROUP BY k.nomina,
					k.periodo,
					k.codigo,
					de.email,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre),
					p.inicio,
					p.cierre,
					p.dias,
					k.empresa,
					k.tiponom,
					n.nomina
	) AS kardexTable
	ORDER BY codigo
END 

IF @otr <>''
BEGIN 
	INSERT INTO @kardex
        ( nomina ,
          periodo ,
          codigo ,
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          tipo ,
          empresa, 
          tiponom, 
          nombretipo
        )
	SELECT nomina,periodo,codigo,nombre,inicio,cierre,dias,sueldo,percepciones,deducciones,isr,imss,percepciones-deducciones AS neto,mail,4 AS tipo,empresa, tiponom, nombreTipo
	FROM(
			SELECT	k.nomina,
					k.periodo,
					k.codigo,
					de.email AS mail,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS nombre,
					CONVERT(NVARCHAR(30),p.inicio,103) AS inicio,
					CONVERT(NVARCHAR(30),p.cierre,103) AS cierre,
					p.dias,
					SUM(CASE WHEN k.num_conc<=7 THEN k.importe ELSE 0 end) AS sueldo,
					SUM(CASE WHEN k.num_conc>=1 AND k.num_conc<=99 THEN k.importe ELSE 0 end) AS percepciones,
					SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=199 THEN k.importe ELSE 0 end) AS deducciones,
					SUM(CASE WHEN k.num_conc=136 THEN k.importe ELSE 0 end) AS isr,
					SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=106 THEN k.importe ELSE 0 end) AS imss,
					k.empresa,
					(case  
					when  k.tiponom=1 then 'Semanal'
					when  k.tiponom=2 then 'Decenal'
					when  k.tiponom=3 then 'Catorcenal'
					when  k.tiponom=4 then 'Quincenal'
					when  k.tiponom=5 then 'Mensual'
					when  k.tiponom=6 then 'Especial'
				end) as tiponom, isnull(n.nomina,'') as nombreTipo 
			FROM dbo.kardex_anual AS k 
			INNER JOIN dbo.empleados AS e ON k.empresa = e.empresa AND k.codigo = e.codigo
			INNER JOIN dbo.datosemps AS de ON e.empresa = de.empresa AND e.codigo = de.codigo
			INNER JOIN dbo.Periodos AS p ON k.tiponom = p.tiponom AND k.periodo = p.periodo AND k.ayo_operacion = p.ayo_operacion AND k.empresa = p.empresa
			INNER JOIN dbo.tmpAccesoPortalPatron AS tmp ON k.empresa = tmp.empresa AND tmp.llave=@llave
			inner join dbo.Nominas as n on k.empresa = n.empresa and n.tiponom=k.tiponom
			WHERE	k.ayo_operacion=@ao
					AND (k.periodo>=@periodoI AND k.periodo<=@periodoF)
					AND k.nomina='OTR'
					and k.codigo=@codigo
					and k.empresa=@company
			GROUP BY k.nomina,
					k.periodo,
					k.codigo,
					de.email,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre),
					p.inicio,
					p.cierre,
					p.dias,
					k.empresa,
					k.tiponom,
					n.nomina
	) AS kardexTable
	ORDER BY codigo
END 

IF @fdo <>''
BEGIN 
	INSERT INTO @kardex
        ( nomina ,
          periodo ,
          codigo ,
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          tipo ,
          empresa,
          tiponom,
          nombretipo
        )
	SELECT nomina,periodo,codigo,nombre,inicio,cierre,dias,sueldo,percepciones,deducciones,isr,imss,percepciones-deducciones AS neto,mail,2 AS tipo,empresa,tiponom, nombretipo
	FROM(
			SELECT	'FDO' AS nomina,
					0 AS periodo,
					k.codigo,
					de.email AS mail,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS nombre,
					'  /  /    ' AS inicio,
					'  /  /    ' AS cierre,
					k.dias,
					0 AS sueldo,
					k.importe_p + k.importe_t + k.intereses AS percepciones,
					k.retiros + k.adeudo AS deducciones,
					0 AS isr,
					0 AS imss,
					k.empresa,
					(case  
					when  l.tiponom=1 then 'Semanal'
					when  l.tiponom=2 then 'Decenal'
					when  l.tiponom=3 then 'Catorcenal'
					when  l.tiponom=4 then 'Quincenal'
					when  l.tiponom=5 then 'Mensual'
					when  l.tiponom=6 then 'Especial'
				end) as tiponom ,'' as nombretipo
			FROM dbo.fondo_de_ahorros AS k 
			INNER JOIN dbo.empleados AS e ON k.empresa = e.empresa AND k.codigo = e.codigo
			INNER JOIN dbo.datosemps AS de ON e.empresa = de.empresa AND e.codigo = de.codigo
			INNER JOIN dbo.Llaves AS l ON e.empresa = l.empresa AND e.codigo = l.codigo
			INNER JOIN dbo.tmpAccesoPortalPatron AS tmp ON k.empresa = tmp.empresa AND tmp.llave=@llave
			WHERE	k.ejercicio=@ao
					and k.codigo=@codigo
					and k.empresa=@company
			--GROUP BY k.codigo,
					--e.mail,
					--RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre),
					--k.dias
	) AS kardexTable
	ORDER BY codigo
END 



SELECT nomina ,
          periodo ,
          codigo ,
          tiponom,
          (case when nombretipo='' then tiponom else nombretipo end),
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          empresa
FROM @kardex
where empresa=@company
ORDER BY tipo,CAST(SUBSTRING(inicio,7,4)+SUBSTRING(inicio,4,2)+SUBSTRING(inicio,1,2) AS datetime) DESC

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Obten_PortalDetalleReciboAhorro')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Obten_PortalDetalleReciboAhorro

GO


CREATE PROCEDURE dbo.Obten_PortalDetalleReciboAhorro
    (
      @empresa udtInteger ,
      @codigo udtInteger ,
      @retiro udtInteger 
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON 
    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @title udtStringSize4096
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debug udtInteger

    SET @debug = 0
    SET @whereClauseUsed = 0
    SET @whereClause = ''
    SET @orderByClause = ''
    
    IF OBJECT_ID('dbo.tRws') IS NOT NULL 
        BEGIN
            DROP TABLE dbo.tRws
        END
        
    CREATE TABLE  dbo.tRws 
        (
          empresa INT ,
          num_conc_p INT ,
          concepto_p VARCHAR(45) ,
          importe_p NUMERIC(10, 2) ,
          num_conc_d INT ,
          concepto_d VARCHAR(45) ,
          importe_d NUMERIC(10, 2) ,
          neto NUMERIC(10, 2) ,
          percepciones NUMERIC(10, 2) ,
          deducciones NUMERIC(10, 2) ,
          serial INT ,
          grupo INT
        )

    DECLARE @counter INT
    DECLARE @copias AS udtInteger

    SELECT  @copias = Copias_Recibo
    FROM    dbo.Parametros_Empresas
    WHERE   Empresa = @empresa

    SET @counter = 1 

    WHILE @counter <= 20 
        BEGIN	
            INSERT  INTO dbo.tRws
                    ( empresa, serial, grupo )
            VALUES  ( @empresa, -- empresa - int
                      @counter, -- serial - int
                      1  -- grupo - int
                      )
            SET @counter = @counter + 1
        END

--SET @counter = 1 
    WHILE @counter <= 40
        AND @copias > 1 
        BEGIN 
            INSERT  INTO dbo.tRws
                    ( empresa, serial, grupo )
            VALUES  ( @empresa, -- empresa - int
                      @counter, -- serial - int
                      2  -- grupo - int
                      )
            SET @counter = @counter + 1
        END


    DECLARE @totalRows TABLE
        (
          empresa INT ,
          codigo INT ,
          num_conc_p INT ,
          concepto_p VARCHAR(35) ,
          importe_p NUMERIC(10, 2) ,
          num_conc_d INT ,
          concepto_d VARCHAR(35) ,
          importe_d NUMERIC(10, 2) ,
          percepciones NUMERIC(10, 2) ,
          deducciones NUMERIC(10, 2) ,
          neto NUMERIC(10, 2) ,
          serial INT ,
          grupo VARCHAR(25) ,
          numero INT
        )



    IF @empresa > 0 
        BEGIN
    
            IF @whereClauseUsed = 0 
                BEGIN
	       
                    SET @whereClause = @whereClause + 'WHERE '
                    SET @whereClauseUsed = 1

                END
            ELSE 
                SET @whereClause = @whereClause + ' AND '
	                 
            SET @whereClause = @whereClause + 'a.empresa = '
                + LTRIM(RTRIM(STR(@empresa)))
                 
        END
    IF @codigo > 0 
        BEGIN
    
            IF @whereClauseUsed = 0 
                BEGIN
	       
                    SET @whereClause = @whereClause + 'WHERE '
                    SET @whereClauseUsed = 1

                END
            ELSE 
                SET @whereClause = @whereClause + ' AND '
	                 
            SET @whereClause = @whereClause + 'a.codigo = '
                + LTRIM(RTRIM(STR(@codigo)))
                 
        END
    SET @selectClause = 'SELECT  a.empresa ,' + 'a.codigo,' + 'b.num_conc_p,'
        + 'b.concepto_p,' + 'b.importe_p,' + 'b.num_conc_d,' + 'b.concepto_d,'
        + 'b.importe_d,' + 'b.percepciones,' + 'b.deducciones,' + 'b.neto,'
        + 'b.serial,'
        + 'REPLICATE(''0'',8-LEN(LTRIM(STR(a.codigo))))+LTRIM(STR(a.codigo))+ REPLICATE(''0'',2-LEN(LTRIM(STR(b.grupo))))+LTRIM(STR(b.grupo))+ '+ '''' + REPLICATE('0',2-LEN(LTRIM(STR(@copias))))+LTRIM(STR(@copias))+''''+' AS grupo,'
        + 'b.grupo AS numero '
    SET @fromClause = 'FROM    dbo.fondo_de_ahorros AS a '
        + 'INNER JOIN dbo.tRws AS b ON a.empresa = b.empresa '

    IF @debug = 0 
        BEGIN
            INSERT  INTO @totalRows
                    ( empresa ,
                      codigo ,
                      num_conc_p ,
                      concepto_p ,
                      importe_p ,
                      num_conc_d ,
                      concepto_d ,
                      importe_d ,
                      percepciones ,
                      deducciones ,
                      neto ,
                      serial ,
                      grupo ,
                      numero
                    )
                    EXEC
                        ( @selectClause + @fromClause + @whereClause
                          + @orderByClause
                        )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @orderByClause )
        END

    SELECT  a.empresa ,
            a.codigo ,
            REPLICATE('0', 8 - LEN(LTRIM(STR(a.codigo)))) + LTRIM(STR(a.codigo))
            + REPLICATE('0', 9 - LEN(LTRIM(STR(a.serial))))
            + LTRIM(STR(a.serial)) AS codigoId ,
            RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
            + RTRIM(e.nombre) AS nombre ,
            e.fchalta AS fechaAlta ,
            e.afiliacion AS numeroSeguridadSocial ,
            e.digvera AS digitoVerificador ,
            e.curp ,
            l.centro ,
            c.nomdepto AS nombreCentro ,
            e.cta_bco_no AS cuentaBanco ,
            ba.nombre nombreBanco ,
            l.ocupacion ,
            t.actividad AS categoria ,
            e.tiposal AS tipoSalario ,
            a.serial AS renglon ,
            e.jornada ,
            e.sueldo AS sueldoDiario ,
            e.saldiaint AS salarioBaseCotizacion ,
            l.clase ,
            cl.nombre AS nombreClase ,
            l.supervisor ,
            su.nombre AS nombreSupervisor ,
            NULL AS marcaContraPercepcion ,
            NULL AS numeroConceptoPercepcion ,
            CASE WHEN ( a.serial = 1
                        OR a.serial = 21
                      )
                      AND @retiro = 0 THEN 'AP. FONDO DE AHORRO TRABAJADOR'
                 WHEN ( a.serial = 1
                        OR a.serial = 21
                      )
                      AND @retiro = 1 THEN 'RETIRO PARCIAL'
                 WHEN ( a.serial = 2
                        OR a.serial = 22
                      )
                      AND @retiro = 0 THEN 'AP. FONDO DE AHORRO PATRON'
                 WHEN ( a.serial = 3
                        OR a.serial = 23
                      )
                      AND @retiro = 0
                      AND b.intereses > 0 THEN 'INTERESES  GENERADOS'
                 ELSE ''
            END AS nombreConceptoPercepcion ,
            CASE WHEN ( a.serial = 1
                        OR a.serial = 21
                      )
                      AND @retiro = 0 THEN b.importe_p
                 WHEN ( a.serial = 1
                        OR a.serial = 21
                      )
                      AND @retiro = 1 THEN b.retiros
                 WHEN ( a.serial = 2
                        OR a.serial = 22
                      )
                      AND @retiro = 0 THEN b.importe_t
                 WHEN ( a.serial = 3
                        OR a.serial = 23
                      )
                      AND @retiro = 0
                      AND b.intereses > 0 THEN b.intereses
                 ELSE 0
            END AS importeConceptoPercepcion ,
            NULL AS gravablePercepcion ,
            NULL AS exentoPercepcion ,
            NULL AS saldoPercepcion ,
            '' AS anexoConceptoPercepcion ,
            NULL AS marcaContraDeduccion ,
            NULL AS numeroConceptoDeduccion ,
            CASE WHEN ( ( a.serial = 1
                          OR a.serial = 21
                        )
                        AND b.adeudo > 0
                      )
                      AND @retiro = 0 THEN 'ADEUDO DE FONDO DE AHORRO'
                 WHEN ( ( a.serial = 2
                          OR a.serial = 22
                        )
                        AND b.retiros > 0
                      )
                      AND @retiro = 0 THEN 'RETIRO PARCIAL'
                 ELSE ''	
            END AS nombreConceptoDeduccion ,
            CASE WHEN ( ( a.serial = 1
                          OR a.serial = 21
                        )
                        AND b.adeudo > 0
                      )
                      AND @retiro = 0 THEN b.adeudo
                 WHEN ( ( a.serial = 2
                          OR a.serial = 22
                        )
                        AND b.retiros > 0
                      )
                      AND @retiro = 0 THEN b.retiros
                 ELSE 0
            END AS importeConceptoDeduccion ,
            NULL AS gravableDeduccion ,
            NULL AS exentoDeduccion ,
            NULL AS saldoDeduccion ,
            '' AS anexoConceptoDeduccion ,
            NULL AS numeroConceptoProvision ,
            NULL AS nombreConceptoProvision ,
            NULL AS importeConceptoProvision ,
            '' AS detalle ,
            NULL AS empleados ,
            NULL AS provisionIMSS ,
            NULL AS provisionRCV ,
            NULL AS provisionINFONAVIT ,
            NULL AS retencionIMSS ,
            NULL AS retencionRCV ,
            NULL AS retencionINFONAVIT ,
            NULL AS empleadosConCuentaBancaria ,
            NULL AS empleadosSinCuentaBancaria ,
            NULL AS percepcionesConCuentaBancaria ,
            NULL AS deduccionesConCuentaBancaria ,
            NULL AS percepcionesSinCuentaBancaria ,
            NULL AS deduccionesSinCuentaBancaria ,
            NULL AS basePorcientoSobreNomina ,
            NULL AS poricientoSobreNomina ,
            NULL AS impuestoSobreNomina ,
            NULL AS fondoAhorroAportacionEmpleado ,
            NULL AS fondoAhorroAportacionPatron ,
            NULL AS sueldoNetoGeneral ,
            b.ejercicio AS ejercicio ,
            NULL AS diarioOficialDia ,
            NULL AS diarioOficialMes ,
            NULL AS diarioOficialAyo ,
            NULL AS salarioMinimoDF ,
            NULL AS salatioMinimoRegion ,
            NULL AS eymArt25 ,
            NULL AS eymArt106ii ,
            NULL AS eymArt107 ,
            NULL AS ivArt147 ,
            NULL AS cvArt168ii ,
            NULL AS baseCalculo ,
            NULL AS grupo ,
            '' AS textogrupo ,
            @copias AS cuantosRecibos ,
            a.numero AS numeroRecibo ,
            a.numero AS recibo ,
            CASE WHEN ( a.serial = 20
                        OR a.serial = 40
                      )
                      AND @retiro = 0
                 THEN ( ISNULL(b.importe_p, 0) + ISNULL(b.importe_t, 0)
                        + ISNULL(b.intereses, 0) )
                 WHEN ( a.serial = 20
                        OR a.serial = 40
                      )
                      AND @retiro = 1 THEN ISNULL(b.retiros, 0)
                 ELSE NULL
            END AS percepcionesEmpleado ,
            CASE WHEN ( a.serial = 20
                        OR a.serial = 40
                      )
                      AND @retiro = 0
                 THEN ( ISNULL(b.adeudo, 0) + ISNULL(b.retiros, 0) )
                 ELSE NULL
            END AS deduccionesEmpleado ,
            CASE WHEN ( a.serial = 20
                        OR a.serial = 40
                      )
                      AND @retiro = 0
                 THEN ( ISNULL(b.importe_p, 0) + ISNULL(b.importe_t, 0)
                        + ISNULL(b.intereses, 0) ) - ( ISNULL(b.adeudo, 0)
                                                       + ISNULL(b.retiros, 0) )
                 WHEN ( a.serial = 20
                        OR a.serial = 40
                      )
                      AND @retiro = 1 THEN ISNULL(b.retiros, 0)
                 ELSE NULL
            END AS netoPagarEmpleado ,
            a.grupo AS grupoRecibo ,
            e.rfcalfa AS rfcAlfa ,
            e.rfcnum AS rfcNum ,
            e.rfchomo AS rfcHomo ,
            --ISNULL(ae.acu_cv, 0) AS acumuladoCv ,
            ISNULL(ae.acu_percep, 0) + b.importe_p + b.importe_t AS acumuladoPercepcion ,
            ISNULL(ae.gravable, 0) AS acumuladoPercepcionGtavable ,
            ISNULL(ae.ispt, 0) AS acumuladoISR ,
            ISNULL(ae.acu_info, 0) AS acumuladoInfonavit ,
            ISNULL(ae.acu_sar, 0) AS acumuladoSar ,
            e.mail AS Email,
            e.fchantigua AS fechaAntiguedad ,
            NULL AS esTotal
    FROM    @totalRows AS a
            INNER JOIN dbo.fondo_de_ahorros AS b ON a.empresa = b.empresa
                                                    AND a.codigo = b.codigo
            INNER JOIN dbo.empleados AS e ON b.empresa = e.empresa
                                             AND b.codigo = e.codigo
            INNER JOIN dbo.Llaves AS l ON e.empresa = l.empresa
                                          AND e.codigo = l.codigo
            LEFT JOIN dbo.supervisores AS su ON l.empresa = su.empresa
                                                AND l.supervisor = su.supervisor
            LEFT JOIN dbo.clases AS cl ON l.empresa = cl.empresa
                                          AND l.clase = cl.clase
            LEFT JOIN dbo.tabulador AS t ON l.empresa = t.empresa
                                            AND l.ocupacion = t.ocupacion
            LEFT JOIN dbo.bancos AS ba ON l.banco = ba.banco
            LEFT JOIN dbo.centros AS c ON l.centro = c.centro
                                          AND l.empresa = c.empresa
            LEFT JOIN dbo.empresas AS emp ON ( B.empresa = emp.empresa )
            LEFT JOIN dbo.acum_emps AS ae ON ( ae.codigo = b.codigo
                                               AND ae.empresa = b.empresa
                                               AND ae.ejercicio = emp.ayo_operacion
                                             )
    ORDER BY a.codigo ,
            a.grupo ,
            a.serial

	IF OBJECT_ID('dbo.tRws') IS NOT NULL 
        BEGIN
            DROP TABLE dbo.tRws
        END
        
        
GO

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'pePortalPatronObtenDetalleRecibosFunU' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.pePortalPatronObtenDetalleRecibosFunU
GO

CREATE PROCEDURE dbo.pePortalPatronObtenDetalleRecibosFunU
(
 @nomina udtName,
 @ao udtInteger,
 @periodo udtInteger,
 @codigo udtInteger,
 @tiponom udtInteger,
 @empresa udtInteger,
 @cUsuario varchar(30)
)
 --WITH ENCRYPTION
 
AS
 SET NOCOUNT ON
 DECLARE @cCodigo udtName

 SET @cCodigo = STR(@codigo)

 IF @nomina = 'FDO' BEGIN
  EXEC dbo.Obten_PortalDetalleReciboAhorro @empresa, @codigo , 0
 END 
 ELSE BEGIN
  EXEC dbo.Fun_U_RecibosFijos @empresa,
							  @periodo,
							  @periodo,
							  @ao,
							  @nomina,
							  @tiponom,
							  @cCodigo,
							  1,
							  @cUsuario
         
 END
       
GO

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'peListadoVacacionesR' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.peListadoVacacionesR
GO

CREATE PROCEDURE dbo.peListadoVacacionesR
(
	@companyID udtInteger,
	@codigo udtInteger,
	@afiliacion varchar(15)
)
	with ENCRYPTION
	
AS
	SET NOCOUNT ON
	
	DECLARE @company udtInteger

    SET @company = CASE WHEN ISNULL((SELECT emps_todas FROM dbo.PortalEmpleadoConfig WHERE llave=1),'N') = 'S' THEN 0 ELSE @companyId END


	SELECT		
		empleados.codigo,
		empleados.nombre,
		empleados.ap_paterno,
		empleados.ap_materno,
		isnull(hist_vac.disfrute,'') as disfrute,
        isnull(hist_vac.prima_vac,0) as prima_vac,
        isnull(hist_vac.prima_v_im,0) as prima_v_im,
        isnull(hist_vac.prima_v_ds,0) as prima_v_ds,
        isnull(hist_vac.dias_tab,0) as dias_tab,
        isnull(hist_vac.dias_disfr,0)+isnull(hist_vac.disf_ant,0) as dias_disfr,       
        isnull(hist_vac.descansos,0) as descansos,
        isnull(hist_vac.festivos,0) as festivos
	FROM empresas empresas 
	INNER JOIN empleados empleados ON empresas.empresa = empleados.empresa
	inner JOIN hist_vac hist_vac ON empleados.empresa = hist_vac.empresa AND empleados.codigo = hist_vac.codigo and hist_vac.marca <> 'A'
	WHERE empleados.codigo = @codigo AND
		  empresas.empresa = @company and		    
		  rtrim(empleados.rfcalfa) + rtrim(empleados.rfcnum) + rtrim(empleados.rfchomo)= @afiliacion
		  
		  
GO    

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'peListadoVacacionesPantalla' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.peListadoVacacionesPantalla
GO

CREATE PROCEDURE dbo.peListadoVacacionesPantalla
(
	@companyID udtInteger,
	@codigo udtInteger,
	@condicion char(1),
	@fechaDe udtdatetime,
	@fechaA udtdatetime,
	@afiliacion varchar(15)
)
	with ENCRYPTION
	
AS
	SET NOCOUNT ON
	
	declare @selectStatement as varchar(1024)
	declare @fromStatement as varchar(1024)
	declare @whereStatement as varchar(2048)
	declare @orderbyStatement as varchar(1024)
	DECLARE @company udtInteger
	
	set @selectStatement = ''
	set @fromStatement = ''
	set @whereStatement =''
	set @orderbyStatement =''
	
	SET @company = CASE WHEN ISNULL((SELECT emps_todas FROM dbo.PortalEmpleadoConfig WHERE llave=1),'N') = 'S' THEN 0 ELSE @companyId END	

	set @selectStatement=' Select empleados.codigo,
						   RTRIM(LTRIM(empleados.ap_paterno)) + '' '' + RTRIM(LTRIM(empleados.ap_materno)) + '' '' + RTRIM(LTRIM(empleados.nombre)) as nombre,
							CONVERT(VARCHAR(10),isnull(hist_vac.disfrute,''''),103) as disfrute,							
							isnull(hist_vac.dias_tab,0) as dias_tab,
							isnull(hist_vac.dias_disfr,0) + isnull(hist_vac.disf_ant,0) as dias_disfr,   
							isnull(hist_vac.dias_ant,0)  as dias_ant ,    
							isnull(hist_vac.prima_vac,0) as prima_vac,
							isnull(hist_vac.prima_v_im,0) as prima_v_im,
							isnull(hist_vac.prima_v_ds,0) as prima_v_ds,
							isnull(hist_vac.descansos,0) as descansos,
							isnull(hist_vac.festivos,0) as festivos
							'
					
	set @fromStatement= ' FROM empresas empresas 
							INNER JOIN empleados empleados ON empresas.empresa = empleados.empresa
							inner JOIN hist_vac hist_vac ON empleados.empresa = hist_vac.empresa 
							AND empleados.codigo = hist_vac.codigo and hist_vac.marca <> ''A'' '			
						
	set @whereStatement= ' where empleados.codigo= ' + convert(varchar(10),@codigo) 
						+ ' AND (ISNULL(dias_disfr,0) > 0 OR ISNULL(dias_ant,0)>0) ' 	
						+ ' and rtrim(empleados.rfcalfa) + rtrim(empleados.rfcnum) + rtrim(empleados.rfchomo)=''' + @afiliacion + ''''
						
	if @condicion='F'
		begin
			set @whereStatement = @whereStatement + ' and hist_vac.disfrute between ''' + convert(varchar(50),@fechaDe,112) 
			 + ''' and ''' + convert(varchar(50),@fechaa,112) + ''' ' 			 
		end				
		
	IF @company > 0
         BEGIN            
             SET @whereStatement = @whereStatement + ' and empleados.empresa = ' + LTRIM(RTRIM(STR(@company)))
         END
					
																
	set @orderbyStatement=' order by hist_vac.disfrute desc '

	
	exec  (@selectStatement+@fromStatement+@whereStatement+@orderbyStatement)

	            
GO      

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'peListadoAusentismo' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.peListadoAusentismo
GO

CREATE PROCEDURE dbo.peListadoAusentismo
(
	@companyID udtInteger,
	@codigo udtInteger,
	@condicion char(1),
	@fechaDe udtdatetime,
	@fechaA udtdatetime,
	@afiliacion varchar(15)
)
	with ENCRYPTION
	
AS
	SET NOCOUNT ON
	
	declare @selectStatement as varchar(1024)
	declare @fromStatement as varchar(1024)
	declare @whereStatement as varchar(2048)
	declare @orderbyStatement as varchar(1024)
	DECLARE @company udtInteger	
	
	set @selectStatement	= ''
	set @fromStatement		= ''
	set @whereStatement		= ''
	set @orderbyStatement	= ''

    SET @company = CASE WHEN ISNULL((SELECT emps_todas FROM dbo.PortalEmpleadoConfig WHERE llave=1),'N') = 'S' THEN 0 ELSE @companyId END	

	set @selectStatement='  Select k.mes, 
							isnull(k.dias,0) as dias,
							k.num_conc, 
							c.concepto, 
							case k.justificar
							when ''P'' then ''PERMISO SIN GOCE DE SUELDO''
							when ''S'' then ''SUSPENCION DISCIPLINARIA'' 
							 when ''T'' then ''PARO TECNICO''
							when ''F'' then ''FALTA''
							else '''' end  as justificar,  
            				convert(varchar(11),k.fch_inicio,103) as fch_inicio,
            				m.codigo,
						    RTRIM(LTRIM(m.ap_paterno)) + '' '' + RTRIM(LTRIM(m.ap_materno)) + '' '' + RTRIM(LTRIM(m.nombre)) as nombre'
					
	set @fromStatement= ' from kardex_anual k, conceptos c , empleados m '	
	
	set @whereStatement=' where k.codigo= ' + convert(varchar(10),@codigo) + '
						  and c.num_conc=k.num_conc 
						  and k.num_conc between 107 and 111 
						  and c.empresa=k.empresa 
						  and m.empresa=k.empresa
						  and m.codigo=k.codigo 
						  and rtrim(m.rfcalfa) + rtrim(m.rfcnum) + rtrim(m.rfchomo)=''' + @afiliacion + ''''
						  
	if @condicion='F'
		BEGIN
			set @whereStatement= @whereStatement + ' and fch_inicio>= ''' + convert(varchar(50),@fechaDe,112)  + ''' 
													 and fch_cierre<= ''' + convert(varchar(50),@fechaa,112) + ''''
		END	
				
																
	set @orderbyStatement=' order by k.periodo desc, k.mes desc '

	 IF @company > 0
		BEGIN
			 SET @whereStatement = @whereStatement + ' and m.empresa = ' + LTRIM(RTRIM(STR(@company)))
		END

	

	exec  (@selectStatement+@fromStatement+@whereStatement+@orderbyStatement)

	            
GO            


IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'pePrestamosOtrasDeducciones' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.pePrestamosOtrasDeducciones
GO

CREATE PROCEDURE dbo.pePrestamosOtrasDeducciones
(
	@companyID udtInteger,
	@codigo udtInteger
)
	with ENCRYPTION
	
AS
	SET NOCOUNT ON
	
	SELECT
		empleados.codigo,
		RTRIM(LTRIM(empleados.ap_paterno)) + ' ' + RTRIM(LTRIM(empleados.ap_materno)) + ' ' + RTRIM(LTRIM(empleados.nombre)) as nombre,
		deducciones.mes_operacion,
		deducciones.periodo,
		deducciones.fch_pago,
		deducciones.numeroinc,
		deducciones.num_cr,
		deducciones.fchinicio,
		deducciones.credito,
		deducciones.plazo,
		deducciones.descuento,
		deducciones.saldo,
		conceptos.num_conc,
		conceptos.concepto
	FROM
		empresas empresas 
		INNER JOIN empleados empleados ON
			empresas.empresa = empleados.empresa
		INNER JOIN deducciones deducciones ON
			empleados.empresa = deducciones.empresa AND
			empleados.codigo = deducciones.codigo
		INNER JOIN conceptos conceptos ON
			deducciones.empresa = conceptos.empresa AND
			deducciones.num_conc = conceptos.num_conc
	WHERE
		conceptos.num_conc >= 100 AND
		conceptos.num_conc <= 199 AND
		conceptos.empresa = @companyid AND
		empleados.codigo = @codigo
	ORDER BY
		deducciones.periodo ASC
	            
GO            

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'peListadoTiempoExtra' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.peListadoTiempoExtra
GO

CREATE PROCEDURE dbo.peListadoTiempoExtra
(
	@companyID udtInteger,
	@codigo udtInteger,
	@condicion char(1),
	@fechaDe udtdatetime,
	@fechaA udtdatetime,
	@afiliacion varchar(15)
)
	with ENCRYPTION
	
AS
	SET NOCOUNT ON
	
	declare @selectStatement as varchar(1024)
	declare @fromStatement as varchar(1024)
	declare @whereStatement as varchar(2048)
	declare @orderbyStatement as varchar(1024)

	DECLARE @company udtInteger	
	
	SET @company = CASE WHEN ISNULL((SELECT emps_todas FROM dbo.PortalEmpleadoConfig WHERE llave=1),'N') = 'S' THEN 0 ELSE @companyId END
	
	set @selectStatement = ''
	set @fromStatement = ''
	set @whereStatement =''
	set @orderbyStatement =''

	set @selectStatement=' Select k.periodo, 
							k.mes, 
							k.num_conc, 
							c.concepto, 
							k.horas,
							convert(varchar(11),k.fch_inicio,103) as fch_inicio,
							m.codigo,
						    RTRIM(LTRIM(m.ap_paterno)) + '' '' + RTRIM(LTRIM(m.ap_materno)) + '' '' + RTRIM(LTRIM(m.nombre)) as nombre'
					
	set @fromStatement= ' from kardex_anual k, conceptos c, empleados m'
	
	
	set @whereStatement=' where k.codigo= ' + convert(varchar(10),@codigo)  + '
						and c.num_conc=k.num_conc
						and k.num_conc between 10 and 13
						and c.empresa=k.empresa
						and m.empresa=k.empresa
						and m.codigo=k.codigo
						and rtrim(m.rfcalfa) + rtrim(m.rfcnum) + rtrim(m.rfchomo)=''' + @afiliacion + ''''
						
     IF @company > 0
		 begin 
			SET @whereStatement = @whereStatement + ' and k.empresa = ' + LTRIM(RTRIM(STR(@company)))
         END
						
	
	if @condicion='F'
		begin
			set @whereStatement= @whereStatement + ' and fch_inicio>= ''' + convert(varchar(50),@fechaDe,112)  + ''' 
													 and fch_cierre<= ''' + convert(varchar(50),@fechaa,112) + ''''
	end					
																
	set @orderbyStatement=' order by k.periodo desc, k.mes desc '

	exec  (@selectStatement+@fromStatement+@whereStatement+@orderbyStatement)

	            
GO   

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'peInfonavit' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.peInfonavit
GO

CREATE PROCEDURE dbo.peInfonavit
(
	@companyID udtInteger,
	@codigo udtInteger
)
	with ENCRYPTION
	
AS
	SET NOCOUNT ON
	
	SELECT
		RTRIM(LTRIM(empleados.ap_paterno)) + ' ' + RTRIM(LTRIM(empleados.ap_materno)) + ' ' + RTRIM(LTRIM(empleados.nombre)) as nombre,
		infonavit.codigo,
		case infonavit.tipo_cred when 1 then 'PORCENTAJE'
								 when 2 then 'CUOTA FIJA'
								 when 3 then 'VSMDF'
								 else '' end as tipo_cred,
		infonavit.numcredito,
		infonavit.descuento,
		infonavit.amortizacion_cedula,
		infonavit.amortizacion_retenido,
		infonavit.amortizacion_sigmes,
		infonavit.fecha,
		infonavit.fch_otorga,
		infonavit.fch_termino
	FROM
		(empresas empresas 
		INNER JOIN empleados empleados ON
			empresas.empresa = empleados.empresa)
		INNER JOIN infonavit infonavit ON
			empleados.empresa = infonavit.empresa AND
			empleados.codigo = infonavit.codigo
	WHERE
		infonavit.codigo = @codigo AND
		infonavit.empresa =@companyID
		            
GO           

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'peFondoDeAhorro' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.peFondoDeAhorro
GO

CREATE PROCEDURE dbo.peFondoDeAhorro
(
	@companyID udtInteger,
	@codigo udtInteger
)
	with ENCRYPTION
	
AS
	SET NOCOUNT ON
	
	SELECT		
		empleados.codigo,
		RTRIM(LTRIM(empleados.ap_paterno)) + ' ' + RTRIM(LTRIM(empleados.ap_materno)) + ' ' + RTRIM(LTRIM(empleados.nombre)) as nombre,
		prestamos_de_fondo.fecha,
		prestamos_de_fondo.credito,
		prestamos_de_fondo.abono,
		prestamos_de_fondo.saldo,
		prestamos_de_fondo.numcredito,
		prestamos_de_fondo.referencia
	FROM
		empresas empresas 
		INNER JOIN empleados empleados ON
			empresas.empresa = empleados.empresa
		INNER JOIN prestamos_de_fondo prestamos_de_fondo ON
			empleados.codigo = prestamos_de_fondo.codigo AND
			empleados.empresa = prestamos_de_fondo.empresa
	WHERE
		empresas.empresa = @companyID
		AND empleados.CODIGO = @CODIGO
	ORDER BY
		prestamos_de_fondo.codigo ASC,
		prestamos_de_fondo.credito ASC
		
GO		

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'peMovimientosIMSS' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.peMovimientosIMSS
GO

CREATE PROCEDURE dbo.peMovimientosIMSS
(
	@companyID udtInteger,
	@codigo udtInteger
)
	with ENCRYPTION
	
AS
	SET NOCOUNT ON

     -- Search criteria: empresa	
	SELECT
		empleados.codigo,
		RTRIM(LTRIM(empleados.ap_paterno)) + ' ' + RTRIM(LTRIM(empleados.ap_materno)) + ' ' + RTRIM(LTRIM(empleados.nombre)) as nombre,
		isnull(avisos_imss.fch_mov,'') as fch_mov,
		CASE avisos_imss.mov WHEN 'IM' then 'Inicio de Mes'
		WHEN 'A' then 'Alta'
		WHEN 'B' then 'Baja'
		WHEN 'MS' then 'Modificacion de Salario'
		else '' end as mov,
		isnull(avisos_imss.saldiaint,0) as saldiaint,
		ISNULL(avisos_imss.mot_baja,'') AS MOT_BAJA
	FROM
		avisos_imss avisos_imss
		INNER JOIN empleados empleados ON
			avisos_imss.empresa = empleados.empresa AND
			avisos_imss.codigo = empleados.codigo
		INNER JOIN empresas empresas ON
			avisos_imss.empresa = empresas.empresa
	WHERE
		avisos_imss.empresa = @companyID
		and avisos_imss.codigo = @codigo
	order by 	
		avisos_imss.fch_mov	
		
GO		

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'peMovimientosSueldo' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.peMovimientosSueldo
GO

CREATE PROCEDURE dbo.peMovimientosSueldo
(
	@companyID udtInteger,
	@codigo udtInteger
)
	with ENCRYPTION
	
AS
	SET NOCOUNT ON
	
	SELECT
		empleados.codigo,
		RTRIM(LTRIM(empleados.ap_paterno)) + ' ' + RTRIM(LTRIM(empleados.ap_materno)) + ' ' + RTRIM(LTRIM(empleados.nombre)) as nombre,
		avisos_imss.empresa,
		avisos_imss.codigo,
		avisos_imss.fch_mov,
		CASE avisos_imss.mov WHEN 'IM' then 'Inicio de Mes'
		WHEN 'A' then 'Alta'
		WHEN 'B' then 'Baja'
		WHEN 'MS' then 'Modificacion de Salario'
		else '' end as mov,
		avisos_imss.saldiaint
	FROM
		empresas empresas
		INNER JOIN empleados empleados ON
			empresas.empresa = empleados.empresa
		INNER JOIN avisos_imss avisos_imss ON
			empleados.empresa = avisos_imss.empresa AND
			empleados.codigo = avisos_imss.codigo
	WHERE
		avisos_imss.mov = 'MS' AND
		avisos_imss.empresa = @companyid  AND
		avisos_imss.codigo = @codigo and
		--avisos_imss.captura<>'V'
		avisos_imss.origen <> 'VA'
	ORDER BY
		avisos_imss.fch_mov ASC
		
GO		

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'peConsultaSolicitudVacaciones' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.peConsultaSolicitudVacaciones
GO

CREATE PROCEDURE dbo.peConsultaSolicitudVacaciones
(
	@companyID udtInteger,
	@codigo udtInteger
)
	with ENCRYPTION
	
AS
	SET NOCOUNT ON
	
	DECLARE @registroPatronal varchar(14)
		
	declare @selectStatement as varchar(1024)
	declare @fromStatement as varchar(1024)
	declare @whereStatement as varchar(2048)
	
	set @selectStatement = ''
	set @fromStatement = ''
	set @whereStatement =''
	
	DECLARE @company udtInteger

    SET @company = CASE WHEN ISNULL((SELECT emps_todas FROM dbo.PortalEmpleadoConfig WHERE llave=1),'N') = 'S' THEN 0 ELSE @companyId END	
	
	select @registroPatronal = registro_patronal
	from empresas
	where empresa=@company
	
	IF @registroPatronal='A3411589106'
		begin			
			set @selectStatement = ' SELECT isnull(dias_ant,0)'
			set @selectStatement = ' SELECT isnull(dias_saldo,0) ' /* + isnull(dias_ant,0)'*/
			set @fromStatement = ' FROM vacaciones'
			set @whereStatement = ' WHERE codigo = ' + convert(varchar(10),@codigo) 
			IF @company > 0
				BEGIN              
					SET @whereStatement = @whereStatement + ' and empresa = ' + LTRIM(RTRIM(STR(@company)))
				END							      					
		end
	else
		begin
			set @selectStatement = 'Select dbo.peSaldoVacacionesProp(' + LTRIM(RTRIM(STR(@company))) + ',' +  convert(varchar(10),@codigo)  + ',''N'')'
		end
		
							      
     
	exec  (@selectStatement+@fromStatement+@whereStatement)
	
GO		

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'peObtenTiposnomRecibos' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.peObtenTiposnomRecibos
GO

create PROCEDURE dbo.peObtenTiposnomRecibos ( 
	@vyear udtInteger,
	@llave udtLong, 
	@codigo bigint )

AS

	BEGIN

		SELECT	ltrim(str(k.tiponom)) + ' ' + rtrim(n.nomina) as nomina
		FROM    dbo.kardex_anual AS k
				LEFT join  nominas as n on k.empresa=n.empresa and k.tiponom=n.tiponom
				LEFT JOIN tmpAccesoPortalPatron  ON n.empresa = tmpAccesoPortalPatron.empresa
		WHERE   k.codigo=@codigo
				and k.ayo_operacion in (@vyear, @vyear-1)
				AND tmpAccesoPortalPatron.llave=@llave
		group by k.tiponom, n.nomina
		ORDER BY k.tiponom
		
	END
	
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'portalEmpleadoActualizaPassword'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.portalEmpleadoActualizaPassword
GO

create PROCEDURE dbo.portalEmpleadoActualizaPassword
    (		
		@passwordNuevo as varchar(15),
		@codigo as bigint,
		@empresa as int
    )
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY 
    
	update empleados 
	set password_empleado= @passwordNuevo
	where codigo= @codigo
	and empresa= @empresa
       
GO	  


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.existeReciboCFDI')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.existeReciboCFDI
GO

CREATE PROCEDURE dbo.existeReciboCFDI
    (
      @empresa udtInteger ,
      @codigo udtInteger ,
      @nomina udtName ,     
      @periodo udtInteger ,
      @ayo_operacion udtInteger
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    
    DECLARE @dataBaseName AS udtName
    DECLARE @sqlString AS udtStringSize4096
    
    SET @dataBaseName = (SELECT DB_NAME() AS [Current Database]) + '_CFDI'
    
    SET @sqlString =' Select  * ' +                  
					' FROM    ' + @dataBaseName	+ '.dbo.CFDI  '+
					' WHERE   empresa = '		+ RTRIM(LTRIM(STR(@empresa ))) +
                            ' AND codigo = '	+ RTRIM(LTRIM(STR(@codigo))) +
                            ' AND ayo_operacion = '+ RTRIM(LTRIM(STR(@ayo_operacion ))) +
                            ' AND periodo = '	+ RTRIM(LTRIM(STR(@periodo ))) + 
                            ' AND nomina = '''	+ @nomina  + '''' 
            
	EXECUTE(@sqlString)
            
GO
 	  	   
IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'[dbo].[PortalEmpleadoWebBitacora]')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE [dbo].[PortalEmpleadoWebBitacora]
            (
              [empresa] [int] NOT NULL ,
              [codigo] [int] NOT NULL ,
              [fecha] [datetime] NOT NULL ,
              [hora] VARCHAR(30) NULL ,
              [serial] BIGINT
                NOT NULL
                IDENTITY
                CONSTRAINT [pk_PortalEmpleadoWebBitacora]
                PRIMARY KEY CLUSTERED
                ( [empresa] ASC, [codigo] ASC, [fecha] DESC, [serial] ASC )
            )
        ON  [PRIMARY]
    END

GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'origen'
                        AND sysobjects.name = 'PortalEmpleadoWebBitacora' ) 
    ALTER TABLE PortalEmpleadoWebBitacora ADD origen VARCHAR(3) NULL 
GO

IF EXISTS ( SELECT  name
            FROM    sysobjects
            WHERE   name = 'AddLogbookEmployee'
                    AND type = 'P' ) 
    DROP PROCEDURE AddLogbookEmployee
    
GO


CREATE PROCEDURE dbo.AddLogbookEmployee
    (
      @companyId udtInteger ,
      @employeeId udtInteger ,
      @dateLog udtDateTime ,
      @hourlog udtName,
      @origen udtName
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    
    INSERT  INTO dbo.PortalEmpleadoWebBitacora
            ( empresa ,
              codigo ,
              fecha ,
              hora,
              origen
            )
    VALUES  ( @companyId ,
              @employeeId ,
              @dateLog ,
              @hourlog,
              @origen   
            )
   
GO

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'peObtenMaildeSupervisor' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.peObtenMaildeSupervisor
GO

create PROCEDURE dbo.peObtenMaildeSupervisor (  @vEmpresa bigint,@vCodigo bigint )

AS

	begin
		select supervisores.email
		from supervisores 
		where supervisores.supervisor=(select llaves.supervisor
										from llaves
										where llaves.empresa=@vEmpresa
										and llaves.codigo=@vcodigo) 
		and supervisores.empresa=@vEmpresa
	end
	
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCargaEmpleadosPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCargaEmpleadosPerfil
GO


CREATE Procedure dbo.usuariosCargaEmpleadosPerfil
	(@idPerfil bigint)
AS 
    BEGIN
    
	Select	e.empresa, 
			e.codigo, 
			rtrim(e.nombre) + ' ' + rtrim(e.ap_paterno)  + ' ' + rtrim(e.ap_materno) as nombreEmpleado,
			t.actividad, 
			c.centro,
			c.nomdepto, 
			ll.clase,
			cl.nombre as nombreclase
    from empleados e
			inner join llaves ll on e.empresa=ll.empresa and e.codigo=ll.codigo
			inner join tabulador t on e.empresa=t.empresa and ll.ocupacion=t.ocupacion
			inner join centros c on e.empresa=c.empresa and ll.centro=c.centro
			inner join clases cl on e.empresa=cl.empresa and cl.clase=ll.clase
			inner join datosemps d on e.empresa=d.empresa and e.codigo=d.codigo		
			inner join perfil_empleado p on e.codigo=p.codigo and e.empresa=p.empresa	
	where e.activo='S'		
			and p.idPerfil=@idPerfil	
	order by e.codigo 
    
	END  
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.insertaEmpleadoPerfilPrimeraVez') and xtype in (N'FN', N'IF', N'TF'))
	DROP PROCEDURE dbo.insertaEmpleadoPerfilPrimeraVez
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'insertaEmpleadoPerfilPrimeraVez'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.insertaEmpleadoPerfilPrimeraVez
GO


CREATE PROCEDURE dbo.insertaEmpleadoPerfilPrimeraVez
AS 
    BEGIN
 -- Declare the return variable here
        DECLARE @perfilPortalEmpleado AS BIGINT
        DECLARE @codigo AS NUMERIC(8, 2)
        DECLARE @empresa AS BIGINT
 
        SELECT  @perfilPortalempleado = idperfil
        FROM    Perfiles
        WHERE   descripcion = 'Admin. Portal del Trabajador'
                AND sistema = 'TP'
                --AND empresas = '{}' 
         
         
        INSERT  INTO PERFIL_EMPLEADO
                ( idPerfil ,
                  Empresa ,
                  Codigo
                                
                )
                SELECT  @perfilPortalempleado ,
                        a.empresa ,
                        a.codigo
                FROM    dbo.empleados AS a
                        LEFT JOIN dbo.perfil_empleado AS b ON a.empresa = b.empresa
                                                              AND a.codigo = b.codigo
                                                              AND b.idPerfil = @perfilPortalempleado
                WHERE   b.empresa IS NULL
                        AND a.activo = 'S'
                        AND NOT a.codigo IN ( SELECT DISTINCT
                                                        codigo
                                              FROM      dbo.perfil_empleado )
  
  
        UPDATE  perfil_Insertado
        SET     insertado = 1
        WHERE   modulo = 'PortalEmpleado'    
 

    END
GO

IF ( SELECT SUM(insertado)
     FROM   perfil_Insertado
     WHERE  modulo = 'PortalEmpleado'
   ) = 0 
    EXEC insertaEmpleadoPerfilPrimeraVez
GO


if (select sum(insertado) from perfil_Insertado where modulo='PortalEmpleado') = 0
	exec insertaEmpleadoPerfilPrimeraVez
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalEmpleado_EmpresasEscritorio'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleado_EmpresasEscritorio
GO

CREATE PROCEDURE dbo.PortalEmpleado_EmpresasEscritorio
    (
      @codigo udtLong ,
      @Password udtName,
	  @Log udtName = 'N'
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @selectClause AS NVARCHAR(4000)
    DECLARE @whereClause AS udtStringSize1024
    DECLARE @orderByClause AS udtStringSize512
    DECLARE @totalRecords AS udtInteger
    DECLARE @startPositionPlusOneElement AS udtInteger
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debugFlag AS udtBoolean
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

		declare @perfiles as table(idPerfil bigint)
		insert into @perfiles
		select idperfil from perfiles where sistema='TP'

		if (select MAX(1) from perfil_empleado where codigo=@codigo) is null
		begin
			INSERT INTO perfil_empleado(idPerfil,empresa,codigo)
			select (select MAX(idPerfil) from @perfiles),
					empresa,
					codigo
			from empleados
			where codigo = @codigo
		end



        DECLARE @Profile AS TABLE
            (
              UserId udtname ,
              [A] udtname ,
              [R] udtname ,
              [B] udtname ,
              [C] udtname ,
              [E] udtname ,
              [F] udtname ,
              [G] udtname ,
			  [H] udtname 
            )
        
        INSERT  INTO @Profile
                ( UserId ,
                  A ,
                  R ,
                  B ,
                  C ,
                  E ,
                  F ,
                  G ,
				  H
                )
                EXEC dbo.GetFunctionsWebByEmployeeEscritorio 'TP', @codigo
        
        --SELECT * FROM @Profile
        DECLARE @decryptedPassword varchar(max)
        SET @decryptedPassword = ( SELECT   dbo.employyedecrypPassword(@Password)
                                 )
        DECLARE @totReg AS TABLE
            (
              empresa udtInteger ,
              regpat udtName ,
              codigo udtInteger ,
              referencia udtStringSize255 ,
              password_empleado udtName ,
              afiliacion udtname ,
              passw udtName ,
              RfcEmp udtName ,
              SaldoVac udtInteger ,
              startPage udtName,
              poblacion udtStringSize255,
			  dias_ant udtinteger,
			  PropEnCurso udtinteger,
			  VenceActual udtinteger,
			  rfc udtname,
			  BloqueaTE varchar(3)
            )
		
        INSERT  INTO @totReg
                ( empresa ,
                  regpat ,
                  codigo ,
                  referencia ,
                  password_empleado ,
                  afiliacion ,
                  passw ,
                  RfcEmp ,
                  SaldoVac ,
                  startPage,
                  poblacion,
				  dias_ant,
				  PropEnCurso,
			      VenceActual,
				  rfc,
				  BloqueaTE
                )
                SELECT  a.empresa ,
                        a.registro_patronal ,
                        b.codigo ,
                        rtrim(CASE WHEN LEN(a.referencia) = 0
                                  OR a.referencia IS NULL
                             THEN a.nombre_empresa
                             ELSE a.referencia
                        END) AS referencia ,
                        CASE WHEN b.password_empleado IS NULL
                                  OR LEN(b.password_empleado) <= 0
                             THEN b.afiliacion
                             ELSE b.password_empleado
                        END AS password_empleado ,
                        b.afiliacion ,
						case when @Log = 'S' then 'A'
						else 
							CASE WHEN b.password_empleado IS NULL
									  OR LEN(b.password_empleado) <= 0 THEN 'A'
								 ELSE 'P'
							END 
						end AS passw ,
                        RTRIM(LTRIM(a.rfc_empresa)) AS RfcEmp ,
                        0 AS SaldoVac ,--ISNULL((SELECT dbo.PortalEmpleadoSaldoVacacionesProp(b.empresa,b.codigo,'S')), 0)  AS SaldoVac ,
                        ISNULL(( SELECT CASE WHEN LEN(ISNULL([A], '')) > 0
                                             THEN 'Vacations.aspx'
                                             WHEN LEN(ISNULL([B], '')) > 0
                                             THEN 'Absenteeism.aspx'
                                             WHEN LEN(ISNULL([C], '')) > 0
                                             THEN 'PaySlip.aspx'
                                             WHEN LEN(ISNULL([R], '')) > 0
                                             THEN 'ReportSearch.aspx'
                                             WHEN LEN(ISNULL([E], '')) > 0
                                             THEN 'OverTime.aspx'
                                             ELSE 'Default.aspx'
                                        END AS startPage
                                 FROM   @Profile
                               ), 'Default.aspx') AS startPage,
                               a.poblacion_empresa,
							   0 as SaldoAnt,--v.dias_ant as SaldoAnt,
							   0 as PropEnCurso,--dbo.PortalEmpleadoSaldoVacacionesProp(b.empresa,b.codigo,'N') PropEnCurso,
							  null as  VenceActual,--YEAR(v.vence) as VenceActual,
							   ltrim(rtrim(b.rfcalfa)) + rtrim(ltrim(str(b.rfcnum)))+ ltrim(rtrim(b.rfchomo)) as RFC,
							   case when bl.codigobloquea is null then 'N' else 'S' end as BloqueaSolTE
                FROM    dbo.empresas AS a
                        INNER JOIN dbo.empleados AS b ON b.empresa = a.empresa
                        --LEFT JOIN dbo.vacaciones AS v ON b.empresa = v.empresa
                        --                                 AND b.codigo = v.codigo
						LEFT join dbo.PortalEmpleadoConfigSolicitudes as bl on bl.empresa=b.empresa and bl.CodigoBloquea=b.codigo
                WHERE   b.codigo = @codigo
                        AND b.activo = 'S'
                        AND ultmov <> 'B'
                ORDER BY a.empresa ASC
                
        declare @mostrarProp as table(prop int)
		declare @empresa int
		select @empresa = empresa from @totReg
		
		insert into @mostrarProp
		exec permisoEmpleadoPerfil  @empresa,@codigo,'A', 'A3'

		Declare @vacaciones as table(codigo int,nombreEmp varchar(100),tiponom int,clase varchar(100),centro varchar(100),Alta datetime,sueldo numeric,saldiaint numeric,dias_tab int,
									 Disfruto int, DiasSaldo int,prima_vac numeric,prima_v_im numeric, prima_V_ds numeric, fchPrima datetime,pagada varchar(100),vence datetime,
									 Salio varchar(100),Disfrute datetime,Dias_Disfr int,Disf_ant int,Fin_Disfru datetime,Descansos int,festivos int,Ordinaria varchar(100), Factorint decimal,
									 marca int, percepcion numeric,deduccion numeric, provision numeric, neto numeric, ds_tab_ant numeric,Dias_Ant numeric,
									 prima_ant numeric, p_v_Ant_imp numeric,
									 p_v_ant_ds numeric, vence_ant datetime, paga_ant varchar(100), estado int, grava_prima numeric,credtotal numeric,subsidio numeric,subsidion numeric,
									 acumulado varchar(100),bitmap varchar(100),empresa int,fch_pago datetime,supervisor int, nombre varchar(100),observaciones varchar(100), ejercicio int, 
									 ejercicio_ant int, tieneAnteriores varchar(100),checkinout varchar(100), proporcion numeric)
		
		--select * from  @vacaciones
		insert into @vacaciones
		exec dbo.Fun_P_Catalogos @nEmpresa=@empresa,@cCatalogo= '[Catalogo GENERAL DE VACACIONES]',@nCodigo=@codigo,@nOrden=0,@nSerial=0,@cusuario= @codigo 

		update a set	PropEnCurso=b.proporcion,
						dias_ant = b.dias_ant
		from @totReg as a
		inner join @vacaciones as b on b.empresa=a.empresa and b.codigo=a.codigo

		--@totReg 
		--select * from @vacaciones
		SELECT  *,
				(select prop from @mostrarProp) as MuestraProp
        FROM    @totReg
        WHERE   codigo = @codigo
                AND ( CASE WHEN passw = 'A' THEN RTRIM(rfc)
                      END = RTRIM(@decryptedPassword)
                      OR CASE WHEN passw = 'P' THEN password_empleado
                         END = @Password
                    )
                

    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION            
GO


if not exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='PortalEmpleadoLogo'   
                  and c.name='rutaFirma')  
  ALTER TABLE PortalEmpleadoLogo add rutaFirma varchar(max) null  
GO  


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'GetFunctionsWebByEmployeeEscritorio'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.GetFunctionsWebByEmployeeEscritorio
GO


CREATE PROCEDURE dbo.GetFunctionsWebByEmployeeEscritorio
    (
      @idSystem udtName ,
      @idUser udtName
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY

    SELECT  UserId ,
            [A] ,
            [R] ,
            [B] ,
            [C] ,
            [E] ,
            [F] ,
            [G] ,
			[H]
    FROM    ( SELECT    b.codigo AS userId ,
                        CASE WHEN d.funcion IS NULL
                                  OR d.funcion = '' THEN 'NO'
                             ELSE 'YES'
                        END permissionByFunction ,
                        d.funcion
              FROM      dbo.perfil_empleado AS b
                        INNER JOIN dbo.perfiles AS c ON b.idperfil = c.idperfil
                                                        AND c.sistema = @idSystem
                        LEFT JOIN dbo.perfil_funcion AS d ON c.idperfil = d.idperfil --AND d.funcion='xx'
              WHERE     b.codigo = @idUser
              GROUP BY  b.codigo ,
                        d.funcion
            ) AS rwsTable PIVOT ( MAX(funcion) FOR funcion IN ( [A], [R], [B],
                                                              [C], [E], [F],
                                                              [G], [H] ) ) AS PivotTable
GO


IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'PortalEmpleadoListadoPoliticas' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoListadoPoliticas
    
GO
CREATE PROCEDURE dbo.PortalEmpleadoListadoPoliticas
(
	@idEmpresa bigint
)
	with ENCRYPTION

AS
	SET NOCOUNT ON
	
	select *
	from  PortalEmpleadoPoliticas 	
	where idempresa=@idEmpresa		  
GO 


IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'PortalEmpleadoGuardaPoliticas' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoGuardaPoliticas
    
GO
CREATE PROCEDURE dbo.PortalEmpleadoGuardaPoliticas
(
	@idEmpresa bigint,
	@idPolitica bigint,
	@nombrePolitica varchar(50),
	@ubicacion varchar(500)
)
	with ENCRYPTION

AS
	SET NOCOUNT ON
	
	if exists (select idPolitica from portalempleadopoliticas where idEmpresa=@idempresa and idPolitica=@idPolitica) 
		update PortalEmpleadoPoliticas 
		set nombrePolitica=@nombrePolitica, 
		ubicacion=@ubicacion
		where idempresa=@idEmpresa
		and idpolitica=@idpolitica
	else
		insert into PortalEmpleadoPoliticas (idEmpresa,idPolitica,nombrePolitica,ubicacion) 
		select @idempresa,isnull(max(idpolitica),0)+1,@nombrePolitica,@ubicacion
		from PortalEmpleadoPoliticas 
		where idEmpresa=@idEmpresa
GO

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'PortalEmpleadoEliminaPolitica' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoEliminaPolitica
    
GO
CREATE PROCEDURE dbo.PortalEmpleadoEliminaPolitica
(
	@idEmpresa bigint,
	@idPolitica bigint
)
	with ENCRYPTION

AS
	SET NOCOUNT ON
	
	Delete from PortalEmpleadoPoliticas where idEmpresa=@idEmpresa and idPolitica=@idPolitica
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[configuraEmailAPSILicencias]') AND type in (N'U'))
DROP TABLE [configuraEmailAPSILicencias]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[configuraEmailAPSIVEIN]') AND type in (N'U'))
DROP TABLE [configuraEmailAPSIVEIN]
GO


IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'PortalEmpleadoInicializaPoliticas' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoInicializaPoliticas
    
GO
CREATE PROCEDURE dbo.PortalEmpleadoInicializaPoliticas
	with ENCRYPTION

AS
	SET NOCOUNT ON
	
	declare @cantidad as int
	
	select @cantidad=count(*)
	from PortalEmpleadoPoliticas
	
	if @cantidad=0
		insert into PortalEmpleadoPoliticas(idpolitica, idEmpresa, nombrePolitica, Ubicacion)
		select max(isnull(idpolitica,0)) +1, empresas.Empresa,'Politicas Generales','Politicas.pdf'
		from empresas
		left join PortalEmpleadoPoliticas on empresas.empresa=PortalEmpleadoPoliticas.idempresa
		group by empresas.Empresa
	  
GO 

exec PortalEmpleadoInicializaPoliticas

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'PortalEmpleadoGuardaLogo' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoGuardaLogo
    
GO

CREATE PROCEDURE  [dbo].[PortalEmpleadoGuardaLogo]
(@idEmpresa as bigint,
@rutaLogo as varchar(max),
@rutaFirma as varchar(max))
AS
begin
	if exists(Select idempresa from PortalEmpleadoLogo where idempresa=@idempresa)
	update PortalEmpleadoLogo set rutaImagen=@rutaLogo, rutaFirma=@rutafirma
	where idempresa=@idempresa
	else
	insert into PortalEmpleadoLogo values (@idempresa,@rutaLogo,@rutaFirma)
end

GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'[dbo].[PortalEmpleado_NoConsolidar]')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN

		CREATE TABLE [dbo].[PortalEmpleado_NoConsolidar](
			[idNoConsolidar] [bigint] NOT NULL,
			[empresa] [int] NOT NULL,
			[codigo] [int] NOT NULL,
			[NoConsolidar] [int] NOT NULL,
		 CONSTRAINT [PK_PortalEmpleado_NoConsolidar] PRIMARY KEY CLUSTERED 
		(
			[idNoConsolidar] ASC
		)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
		) ON [PRIMARY]

    END

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortaEmpleado_MantenimientoConsolidar'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortaEmpleado_MantenimientoConsolidar
GO

CREATE PROCEDURE dbo.PortaEmpleado_MantenimientoConsolidar
(
	@empresa int,
	@codigo int
)

    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON

	if isnull((select top 1 1 from dbo.PortalEmpleado_NoConsolidar where empresa=@empresa and codigo=@codigo),0)>=1
	begin
		update dbo.PortalEmpleado_NoConsolidar set NoConsolidar=case when isnull(NoConsolidar,0)=0 then 1 else 0 end where empresa=@empresa and codigo=@codigo
	end
	else begin
		insert into [dbo].[PortalEmpleado_NoConsolidar](idNoConsolidar,empresa,codigo,NoConsolidar)
		select	isnull((select max(idNoconsolidar) from [dbo].[PortalEmpleado_NoConsolidar]),0)+1,
				@empresa,@codigo,1	
	end
	
GO

IF EXISTS (SELECT *
           FROM   sys.objects
           WHERE  object_id = OBJECT_ID(N'[dbo].[PortalEmpleado_EmpleadoConsolidar]')
                  AND type IN ( N'FN', N'IF', N'TF', N'FS', N'FT' ))
  DROP FUNCTION [dbo].[PortalEmpleado_EmpleadoConsolidar]

GO

CREATE FUNCTION dbo.PortalEmpleado_EmpleadoConsolidar
    (
      @empresa int,
	  @codigo int
    )            
RETURNS  @codigos table (empresa int, codigo int)
AS 
    BEGIN

		insert into @codigos
		select	a.empresa,
				a.codigo--,rtrim(ltrim(a.rfcalfa)) + convert(varchar,a.rfcnum) + rtrim(ltrim(a.rfchomo)),	c.RFCEmpleado,isnull(con.noconsolidar,0) noconsolidar
		from dbo.empleados as a
		outer apply (select top 1 emps_todas from dbo.PortalEmpleadoConfig) as b
		outer apply (select rtrim(ltrim(rfcalfa)) + convert(varchar,rfcnum) + rtrim(ltrim(rfchomo)) RFCEmpleado
					 from dbo.empleados
					 where	empresa=@empresa
								and codigo=@codigo) as c
		left join [dbo].[PortalEmpleado_NoConsolidar] as con on con.empresa=a.empresa and con.codigo=a.codigo
		where	(a.empresa=@empresa and a.codigo=@codigo) or 
		(b.emps_todas = 'S' and  rtrim(ltrim(a.rfcalfa)) + convert(varchar,a.rfcnum) + rtrim(ltrim(a.rfchomo)) = c.RFCEmpleado and isnull(con.noconsolidar,0)=0)


        RETURN 
    END
 GO


 IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalEmpleadoListadoConsolidar'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoListadoConsolidar
GO

CREATE PROCEDURE dbo.PortalEmpleadoListadoConsolidar
(@ntipo as int)
    with ENCRYPTION
AS 
Begin

	select  e.empresa
			,e.codigo
			,rtrim(e.nombre) + ' ' + rtrim(e.ap_paterno)  + ' ' + rtrim(e.ap_materno) as nombreEmpleado
	from empleados e 
	left join  PortalEmpleado_NoConsolidar nc on nc.empresa=e.empresa
			and nc.codigo=e.codigo 
	where  isnull(nc.noconsolidar,0)=@ntipo 

end
GO
 

IF eXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalEmpleadoCargaAyosDeRecibos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoCargaAyosDeRecibos
GO

CREATE PROCEDURE dbo.PortalEmpleadoCargaAyosDeRecibos
(
	@llave bigint,
	@codigo bigint
)
AS 
Begin

   SET NOCOUNT ON

   declare @empresa as bigint
    select @empresa=empresa
    from tmpAccesoPortalPatron
    where llave=@llave

	IF OBJECT_ID(N'dbo.#Historial', N'U') IS NOT NULL  
    begin
		DROP TABLE [dbo].[#Historial]  
	end
	CREATE TABLE #Historial (empresa bigint, codigo bigint)
	INSERT INTO #Historial (empresa,codigo)
	 SELECT empresa,codigo from dbo.PortalEmpleado_EmpleadoConsolidar(@empresa,@codigo)
	
	SET NOCOUNT OFF	

	SELECT DISTINCT k.ayo_operacion
	FROM  kardex_anual AS k
		inner join #Historial h on h.empresa=k.empresa and h.codigo=k.codigo
	order by k.ayo_operacion
		
end
GO

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'PortalEmpleadoCargaTipoNominaDeRecibos' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoCargaTipoNominaDeRecibos
GO

create PROCEDURE dbo.PortalEmpleadoCargaTipoNominaDeRecibos ( 
	@vyear udtInteger,
	@llave udtLong, 
	@codigo bigint )

AS

	BEGIN

	 SET NOCOUNT ON

	    declare @empresa as bigint
		select @empresa=empresa
		from tmpAccesoPortalPatron
		where llave=@llave

	IF OBJECT_ID(N'dbo.#Historial', N'U') IS NOT NULL  
    begin
		DROP TABLE [dbo].[#Historial]  
	end
		CREATE TABLE #Historial (empresa bigint, codigo bigint)
		INSERT INTO #Historial (empresa,codigo)
		SELECT empresa,codigo from dbo.PortalEmpleado_EmpleadoConsolidar(@empresa,@codigo)
	
		SET NOCOUNT OFF	

		SELECT	ltrim(str(k.tiponom)) + ' ' + rtrim(n.nomina) as nomina
		FROM    dbo.kardex_anual AS k
				inner join nominas as n on k.empresa=n.empresa and k.tiponom=n.tiponom
				inner join #Historial h on h.empresa=k.empresa and h.codigo=k.codigo  
		WHERE   k.ayo_operacion = @vyear
		group by k.tiponom, n.nomina
		ORDER BY k.tiponom

	END
GO

   
IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'PortalEmpleadoCargaPeriodosDeRecibos' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoCargaPeriodosDeRecibos
GO

CREATE PROCEDURE dbo.PortalEmpleadoCargaPeriodosDeRecibos
(
	@ayo udtInteger,
	@tiponom udtInteger,
	@codigo udtlong,
	@llave udtLong
)


AS
BEGIN
	SET NOCOUNT ON

	    declare @empresa as bigint
		select @empresa=empresa
		from tmpAccesoPortalPatron
		where llave=@llave

	IF OBJECT_ID(N'dbo.#Historial', N'U') IS NOT NULL  
    begin
		DROP TABLE [dbo].[#Historial]  
	end
		CREATE TABLE #Historial (empresa bigint, codigo bigint)
		INSERT INTO #Historial (empresa,codigo)
		SELECT empresa,codigo from dbo.PortalEmpleado_EmpleadoConsolidar(@empresa,@codigo)
	
	   SET NOCOUNT OFF	

		SELECT  LTRIM(STR(k.periodo)) AS periodo
		FROM kardex_anual k
				inner join #Historial h on h.empresa=k.empresa and h.codigo=k.codigo
		WHERE k.ayo_operacion =  @ayo
				AND k.tiponom=@tiponom
		GROUP BY k.periodo
		ORDER BY k.periodo asc

end
GO


IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'PortalEmpleadoCargaListadoDeRecibos' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoCargaListadoDeRecibos
GO

CREATE PROCEDURE dbo.PortalEmpleadoCargaListadoDeRecibos
(
	@tiponom udtInteger,
	@ao udtInteger,
	@periodoI udtInteger,
	@periodoF udtInteger,
	@agi udtName,
	@fdo udtName,
	@otr udtName,
	@llave bigint,
	@codigo bigint	,
	@afiliacion varchar(15),
	@company bigint
)
AS
	SET NOCOUNT ON 

	    declare @empresa as bigint
		select @empresa=empresa
		from tmpAccesoPortalPatron
		where llave=@llave

		IF OBJECT_ID(N'dbo.#Historial', N'U') IS NOT NULL  
		begin
			DROP TABLE [dbo].[#Historial]  
		end
		CREATE TABLE #Historial (empresa bigint, codigo bigint)
		INSERT INTO #Historial (empresa,codigo)
		SELECT empresa,codigo from dbo.PortalEmpleado_EmpleadoConsolidar(@empresa,@codigo)

/*DECLARE @company udtInteger

SET @company = CASE WHEN ISNULL((SELECT emps_todas FROM dbo.PortalEmpleadoConfig WHERE llave=1),'N') = 'S' THEN 0 ELSE @companyId END	*/
	
DECLARE @kardex TABLE (nomina udtName,periodo udtInteger,codigo udtInteger,nombre udtName,inicio udtName,cierre udtName, dias udtNumeric10_2,sueldo udtNumeric10_2,percepciones udtNumeric10_2,deducciones udtNumeric10_2,isr udtNumeric10_2,imss udtNumeric10_2, neto udtNumeric10_2, mail udtName, tipo udtInteger, empresa udtInteger, tiponom udtname, nombretipo udtname)

INSERT INTO @kardex
        ( nomina ,
          periodo ,
          codigo ,
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          tipo,
          empresa, 
          tiponom,
          nombretipo
        )
SELECT nomina,periodo,codigo,nombre,inicio,cierre,dias,sueldo,percepciones,deducciones,isr,imss,percepciones-deducciones AS neto,mail,3 AS tipo,empresa, tiponom, nombretipo
FROM(
		SELECT	k.nomina,
				k.periodo,
				k.codigo,
				ISNULL(de.email,'') AS mail,
				RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS nombre,
				CONVERT(NVARCHAR(30),p.inicio,103) AS inicio,
				CONVERT(NVARCHAR(30),p.cierre,103) AS cierre,
				p.dias,
				SUM(CASE WHEN k.num_conc<=7 THEN k.importe ELSE 0 end) AS sueldo,
				SUM(CASE WHEN k.num_conc>=1 AND k.num_conc<=99 THEN k.importe ELSE 0 end) AS percepciones,
				SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=199 THEN k.importe ELSE 0 end) AS deducciones,
				SUM(CASE WHEN k.num_conc=136 THEN k.importe ELSE 0 end) AS isr,
				SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=106 THEN k.importe ELSE 0 end) AS imss,
				k.empresa, 
				(case  
					when  k.tiponom=1 then 'Semanal'
					when  k.tiponom=2 then 'Decenal'
					when  k.tiponom=3 then 'Catorcenal'
					when  k.tiponom=4 then 'Quincenal'
					when  k.tiponom=5 then 'Mensual'
					when  k.tiponom=6 then 'Especial'
				end) as tiponom, isnull(n.nomina,'') as nombreTipo 
		FROM dbo.kardex_anual AS k 
		inner JOIN dbo.empleados AS e ON k.empresa = e.empresa AND k.codigo = e.codigo
		inner JOIN dbo.datosemps AS de ON e.empresa = de.empresa AND e.codigo = de.codigo
		inner JOIN dbo.Periodos AS p ON k.tiponom = p.tiponom AND k.periodo = p.periodo AND k.ayo_operacion = p.ayo_operacion AND k.empresa = p.empresa
		inner join #Historial h on h.empresa=k.empresa and h.codigo=k.codigo
		inner join dbo.Nominas as n on k.empresa = n.empresa and n.tiponom=k.tiponom
		WHERE	k.ayo_operacion=@ao
				AND (k.periodo>=@periodoI AND k.periodo<=@periodoF)
				AND k.nomina='ORD'
				--and k.codigo =@codigo
				--and k.empresa=@company
		GROUP BY k.nomina,
				k.periodo,
				k.codigo,
				de.email,
				RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre),
				p.inicio,
				p.cierre,
				p.dias,
				k.empresa,
				k.tiponom,
				n.nomina
) AS kardexTable
ORDER BY codigo,tiponom DESC,periodo DESC


IF @agi <>''
BEGIN 
	delete from @kardex 
	
	INSERT INTO @kardex
        ( nomina ,
          periodo ,
          codigo ,
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          tipo ,
          empresa, 
          tiponom,
          nombretipo
        )
	SELECT nomina,periodo,codigo,nombre,inicio,cierre,dias,sueldo,percepciones,deducciones,isr,imss,percepciones-deducciones AS neto,mail,1 AS tipo,empresa, tiponom, nombretipo
	FROM(
			SELECT	k.nomina,
					k.periodo,
					k.codigo,
					de.email AS mail,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS nombre,
					CONVERT(NVARCHAR(30),p.inicio,103) AS inicio,
					CONVERT(NVARCHAR(30),p.cierre,103) AS cierre,
					p.dias,
					SUM(CASE WHEN k.num_conc<=7 THEN k.importe ELSE 0 end) AS sueldo,
					SUM(CASE WHEN k.num_conc>=1 AND k.num_conc<=99 THEN k.importe ELSE 0 end) AS percepciones,
					SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=199 THEN k.importe ELSE 0 end) AS deducciones,
					SUM(CASE WHEN k.num_conc=136 THEN k.importe ELSE 0 end) AS isr,
					SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=106 THEN k.importe ELSE 0 end) AS imss,
					k.empresa,
					(case  
					when  k.tiponom=1 then 'Semanal'
					when  k.tiponom=2 then 'Decenal'
					when  k.tiponom=3 then 'Catorcenal'
					when  k.tiponom=4 then 'Quincenal'
					when  k.tiponom=5 then 'Mensual'
					when  k.tiponom=6 then 'Especial'
				end) as tiponom, isnull(n.nomina,'') as nombreTipo 
			FROM dbo.kardex_anual AS k 
			INNER JOIN dbo.empleados AS e ON k.empresa = e.empresa AND k.codigo = e.codigo
			INNER JOIN dbo.datosemps AS de ON e.empresa = de.empresa AND e.codigo = de.codigo
			INNER JOIN dbo.Periodos AS p ON k.tiponom = p.tiponom AND k.periodo = p.periodo AND k.ayo_operacion = p.ayo_operacion AND k.empresa = p.empresa
			inner join #Historial h on h.empresa=k.empresa and h.codigo=k.codigo
			inner join dbo.Nominas as n on k.empresa = n.empresa and n.tiponom=k.tiponom
			WHERE	 k.ayo_operacion=@ao
					AND k.nomina='AGI'
					--and k.codigo=@codigo
			GROUP BY k.nomina,
					k.periodo,
					k.codigo,
					de.email,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre),
					p.inicio,
					p.cierre,
					p.dias,
					k.empresa,
					k.tiponom,
					n.nomina
	) AS kardexTable
	ORDER BY codigo
END 

IF @otr <>''
BEGIN 
	delete from @kardex 
	
	INSERT INTO @kardex
        ( nomina ,
          periodo ,
          codigo ,
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          tipo ,
          empresa, 
          tiponom, 
          nombretipo
        )
	SELECT nomina,periodo,codigo,nombre,inicio,cierre,dias,sueldo,percepciones,deducciones,isr,imss,percepciones-deducciones AS neto,mail,4 AS tipo,empresa, tiponom, nombreTipo
	FROM(
			SELECT	k.nomina,
					k.periodo,
					k.codigo,
					de.email AS mail,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS nombre,
					CONVERT(NVARCHAR(30),p.inicio,103) AS inicio,
					CONVERT(NVARCHAR(30),p.cierre,103) AS cierre,
					p.dias,
					SUM(CASE WHEN k.num_conc<=7 THEN k.importe ELSE 0 end) AS sueldo,
					SUM(CASE WHEN k.num_conc>=1 AND k.num_conc<=99 THEN k.importe ELSE 0 end) AS percepciones,
					SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=199 THEN k.importe ELSE 0 end) AS deducciones,
					SUM(CASE WHEN k.num_conc=136 THEN k.importe ELSE 0 end) AS isr,
					SUM(CASE WHEN k.num_conc>=101 AND k.num_conc<=106 THEN k.importe ELSE 0 end) AS imss,
					k.empresa,
					(case  
					when  k.tiponom=1 then 'Semanal'
					when  k.tiponom=2 then 'Decenal'
					when  k.tiponom=3 then 'Catorcenal'
					when  k.tiponom=4 then 'Quincenal'
					when  k.tiponom=5 then 'Mensual'
					when  k.tiponom=6 then 'Especial'
				end) as tiponom, isnull(n.nomina,'') as nombreTipo 
			FROM dbo.kardex_anual AS k 
			INNER JOIN dbo.empleados AS e ON k.empresa = e.empresa AND k.codigo = e.codigo
			INNER JOIN dbo.datosemps AS de ON e.empresa = de.empresa AND e.codigo = de.codigo
			INNER JOIN dbo.Periodos AS p ON k.tiponom = p.tiponom AND k.periodo = p.periodo AND k.ayo_operacion = p.ayo_operacion AND k.empresa = p.empresa
			inner join #Historial h on h.empresa=k.empresa and h.codigo=k.codigo
			inner join dbo.Nominas as n on k.empresa = n.empresa and n.tiponom=k.tiponom
			WHERE	k.ayo_operacion=@ao
					AND (k.periodo>=@periodoI AND k.periodo<=@periodoF)
					AND k.nomina='OTR'
					--and k.codigo=@codigo
					--and k.empresa=@company
			GROUP BY k.nomina,
					k.periodo,
					k.codigo,
					de.email,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre),
					p.inicio,
					p.cierre,
					p.dias,
					k.empresa,
					k.tiponom,
					n.nomina
	) AS kardexTable
	ORDER BY codigo
END 

IF @fdo <>''
BEGIN 
	delete from @kardex 
	
	INSERT INTO @kardex
        ( nomina ,
          periodo ,
          codigo ,
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          tipo ,
          empresa,
          tiponom,
          nombretipo
        )
	SELECT nomina,periodo,codigo,nombre,inicio,cierre,dias,sueldo,percepciones,deducciones,isr,imss,percepciones-deducciones AS neto,mail,2 AS tipo,empresa,tiponom, nombretipo
	FROM(
			SELECT	'FDO' AS nomina,
					0 AS periodo,
					k.codigo,
					de.email AS mail,
					RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS nombre,
					'  /  /    ' AS inicio,
					'  /  /    ' AS cierre,
					k.dias,
					0 AS sueldo,
					k.importe_p + k.importe_t + k.intereses AS percepciones,
					k.retiros + k.adeudo AS deducciones,
					0 AS isr,
					0 AS imss,
					k.empresa,
					(case  
					when  l.tiponom=1 then 'Semanal'
					when  l.tiponom=2 then 'Decenal'
					when  l.tiponom=3 then 'Catorcenal'
					when  l.tiponom=4 then 'Quincenal'
					when  l.tiponom=5 then 'Mensual'
					when  l.tiponom=6 then 'Especial'
				end) as tiponom ,'' as nombretipo
			FROM dbo.fondo_de_ahorros_anual AS k 
			INNER JOIN dbo.empleados AS e ON k.empresa = e.empresa AND k.codigo = e.codigo
			INNER JOIN dbo.datosemps AS de ON e.empresa = de.empresa AND e.codigo = de.codigo
			INNER JOIN dbo.Llaves AS l ON e.empresa = l.empresa AND e.codigo = l.codigo
			inner join #Historial h on h.empresa=k.empresa and h.codigo=k.codigo
			WHERE	k.ejercicio=@ao
					--and k.codigo=@codigo
					--and k.empresa=@company
					and rtrim(e.rfcalfa) + rtrim(e.rfcnum) + rtrim(e.rfchomo) = @afiliacion
	) AS kardexTable
	ORDER BY codigo
END 



SELECT nomina ,
          periodo ,
          codigo ,
          tiponom,
          (case when nombretipo='' then tiponom else nombretipo end),
          nombre ,
          inicio ,
          cierre ,
          dias ,
          sueldo ,
          percepciones ,
          deducciones ,
          isr ,
          imss ,
          neto ,
          mail ,
          empresa
FROM @kardex

ORDER BY tipo,CAST(SUBSTRING(inicio,7,4)+SUBSTRING(inicio,4,2)+SUBSTRING(inicio,1,2) AS datetime) DESC

GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.syscolumns
                WHERE   id = OBJECT_ID('dbo.Perfiles')
                        AND name = 'PortalEmp' ) 
    ALTER TABLE dbo.Perfiles ADD PortalEmp int
GO

update dbo.perfiles set PortalEmp=1,sueldo='S' where PortalEmp is null and sistema='TP'


GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'permisoEmpleadoVerSueldo'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.permisoEmpleadoVerSueldo
GO


CREATE PROCEDURE permisoEmpleadoVerSueldo
(
	@empresa as bigint,
	@codigo as bigint
)


AS
BEGIN

	select isnull(Sueldo,'N') as versueldo
	from perfiles   
		left join perfil_empleado on perfiles.idperfil=perfil_empleado.idperfil
	where perfil_empleado.codigo=@codigo
	and perfil_empleado.empresa=@empresa
	and perfiles.sistema='TP'

END
GO