


if not exists (select * from dbo.sysobjects  
                 where id = object_id(N'dbo.configuraEmail') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
  
CREATE TABLE dbo.configuraEmail(
	idConfiguracion varchar(50) NULL,
	MailServer varchar(50) NULL,
	MailAddress varchar(50) NULL,
	Puerto varchar(50) NULL,
	CC varchar(50) NULL,
	a_user varchar(50) NULL,
	a_pwd varchar(50) NULL,
	autenticacion varchar(50) NULL,	
	tipoAutenticacion varchar(50) NULL,
	nombreMail varchar(50) NULL,
	PuestoMail varchar(50) NULL
) 

GO

if not exists (select * from dbo.sysobjects  
                 where id = object_id(N'dbo.configuraEmailPortalEmpleado') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
 
CREATE TABLE [dbo].[configuraEmailPortalEmpleado](
	[idEmpresa] [bigint] NOT NULL,
	[idConfiguracion] [varchar](50) NULL,
	[MailServer] [varchar](50) NULL,
	[MailAddress] [varchar](50) NULL,
	[Puerto] [varchar](50) NULL,
	[CC] [varchar](50) NULL,
	[a_user] [varchar](50) NULL,
	[a_pwd] [varchar](50) NULL,
	[autenticacion] [varchar](50) NULL,
	[tipoAutenticacion] [varchar](50) NULL,
	[nombreMail] [varchar](50) NULL,
	[PuestoMail] [varchar](50) NULL,
	[cSSL] [varchar](2) NULL,
	[cTSL] [varchar](2) NULL,
	[MailRecepcionRH] [varchar](250) NULL
) ON [PRIMARY]

GO

IF not EXISTS(select syscolumns.name  from syscolumns 
	left join sysobjects on syscolumns.id=sysobjects.id
	where syscolumns.name = 'cSSL' and sysobjects.name='configuraEmail')
	Alter table dbo.configuraEmail add cSSL varchar(2) null    
	              
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
	left join sysobjects on syscolumns.id=sysobjects.id
	where syscolumns.name = 'cTSL' and sysobjects.name='configuraEmail')
	Alter table dbo.configuraEmail add cTSL varchar(2) null    
	              
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
	left join sysobjects on syscolumns.id=sysobjects.id
	where syscolumns.name = 'MailRecepcionRH' and sysobjects.name='configuraEmail')
	Alter table dbo.configuraEmail add MailRecepcionRH varchar(250) null    
	              
GO
IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'getConfiguraMail' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.getConfiguraMail
    
GO
CREATE PROCEDURE dbo.getConfiguraMail
	with ENCRYPTION

AS
	SET NOCOUNT ON	
						
	SELECT MailServer
		  ,MailAddress
		  ,Puerto
		  ,CC
		  ,a_user
		  ,a_pwd
		  ,autenticacion
		  ,tipoAutenticacion
		  ,nombreMail
		  ,PuestoMail
		  ,cSSL
		  ,cTSL
		  ,MailRecepcionRH
	FROM configuraEmail
  
GO

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'updateConfiguraMail' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.updateConfiguraMail
    
GO
CREATE PROCEDURE dbo.updateConfiguraMail
(
	@ServidorMail varchar(50),
	@Mail varchar(50),
	@Puerto varchar(50),
	@ConCopiaPara varchar(50),
	@mail_user varchar(50),
	@mail_pwd varchar(50),
	@autenticacion varchar(50),
	@tipoAutenticacion varchar(50),
	@NombreMail varchar(50),
	@PuestoMail varchar(50),
	@SSL varchar(2),
	@TSL varchar(2),
	@MailRecepcionRH varchar(250)
)
	with ENCRYPTION

AS
	SET NOCOUNT ON
	
	declare @existe udtName
	
	select @existe=count(idConfiguracion)
	from configuraEmail
	
	if @existe=0
		INSERT INTO configuraEmail
			   (idConfiguracion
			   ,MailServer
			   ,MailAddress
			   ,Puerto
			   ,CC
			   ,a_user
			   ,a_pwd
			   ,autenticacion
			   ,tipoAutenticacion
			   ,nombreMail
			   ,PuestoMail
			   ,cSSL
			   ,cTSL
			   ,MailRecepcionRH)
		 VALUES
			   (1
			   ,@ServidorMail
			   ,@Mail
			   ,@Puerto
			   ,@ConCopiaPara
			   ,@mail_user
			   ,@mail_pwd
			   ,@autenticacion
			   ,@tipoAutenticacion
			   ,@NombreMail
			   ,@PuestoMail
			   ,@SSL
			   ,@TSL
			   ,@MailRecepcionRH)
	else
		UPDATE configuraEmail
		 SET MailServer = @ServidorMail
		  ,MailAddress =@Mail
		  ,Puerto = @Puerto
		  ,CC = @ConCopiaPara
		  ,a_user = @mail_user
		  ,a_pwd =@mail_pwd
		  ,autenticacion = @autenticacion
		  ,tipoAutenticacion = @tipoAutenticacion
		  ,nombreMail=@NombreMail
		  ,puestoMail=@PuestoMail	 
		  ,cSSL=@SSL
		  ,cTSL=@TSL
		  ,MailRecepcionRH=@MailRecepcionRH
		where idConfiguracion=1		   			  
GO

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'configuracionEmailNomina' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.configuracionEmailNomina
    
GO
CREATE PROCEDURE dbo.configuracionEmailNomina
(
	@companyID bigint
)
	with ENCRYPTION

AS
	SET NOCOUNT ON
	
	SELECT isnull(ServidorDeCorreo,'') as  ServidorDeCorreo
      ,isnull(DireccionDeCorreo,'') as  DireccionDeCorreo
      ,isnull(PuertoDeCorreo,0) as  PuertoDeCorreo
      ,isnull(EnviarCorreo,'') as  EnviarCorreo
      ,isnull(UsuarioDeCorreo,'') as  UsuarioDeCorreo
      ,isnull(PasswordDeCorreo,'') as  PasswordDeCorreo
      ,isnull(AutentificacionCorreo,'') as  AutentificacionCorreo
      ,isnull(TipoAutentificacionCorreo,'') as  TipoAutentificacionCorreo
      ,isnull(SSL,'') as  SSL
      ,isnull(TLS,'') as  TLS
      ,isnull(MensajeDeCorreo,'') as  MensajeDeCorreo
  FROM Parametros_Empresas
  WHERE empresa=@companyid
  
GO

IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'PortalEmpleadoConfiguraMail' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoConfiguraMail
    
GO
CREATE PROCEDURE dbo.PortalEmpleadoConfiguraMail
(
	@idEmpresa bigint,
	@ServidorMail varchar(50),
	@Mail varchar(50),
	@Puerto varchar(50),
	@ConCopiaPara varchar(50),
	@mail_user varchar(50),
	@mail_pwd varchar(50),
	@autenticacion varchar(50),
	@tipoAutenticacion varchar(50),
	@NombreMail varchar(50),
	@PuestoMail varchar(50),
	@SSL varchar(2),
	@TSL varchar(2),
	@MailRecepcionRH varchar(250)
)
	with ENCRYPTION

AS
	SET NOCOUNT ON
	
	declare @existe udtName
	
	select @existe=count(idempresa)
	from configuraEmailPortalEmpleado
	where idempresa=@idempresa
	
	if @existe=0
		INSERT INTO configuraEmailPortalEmpleado
			   (idempresa
			   ,idconfiguracion
			   ,MailServer
			   ,MailAddress
			   ,Puerto
			   ,CC
			   ,a_user
			   ,a_pwd
			   ,autenticacion
			   ,tipoAutenticacion
			   ,nombreMail
			   ,PuestoMail
			   ,cSSL
			   ,cTSL
			   ,MailRecepcionRH)
		select @idempresa
			   ,isnull(MAX(idConfiguracion),0) + 1
			   ,@ServidorMail
			   ,@Mail
			   ,@Puerto
			   ,@ConCopiaPara
			   ,@mail_user
			   ,@mail_pwd
			   ,@autenticacion
			   ,@tipoAutenticacion
			   ,@NombreMail
			   ,@PuestoMail
			   ,@SSL
			   ,@TSL
			   ,@MailRecepcionRH
			   from configuraEmailPortalEmpleado
	else
		UPDATE configuraEmailPortalEmpleado
		 SET MailServer = @ServidorMail
		  ,MailAddress =@Mail
		  ,Puerto = @Puerto
		  ,CC = @ConCopiaPara
		  ,a_user = @mail_user
		  ,a_pwd =@mail_pwd
		  ,autenticacion = @autenticacion
		  ,tipoAutenticacion = @tipoAutenticacion
		  ,nombreMail=@NombreMail
		  ,puestoMail=@PuestoMail	 
		  ,cSSL=@SSL
		  ,cTSL=@TSL
		  ,MailRecepcionRH=@MailRecepcionRH
		where idempresa=@idempresa		   			  
GO 


IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'getConfiguraMailPortalEmpleado' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.getConfiguraMailPortalEmpleado
    
GO

CREATE PROCEDURE dbo.getConfiguraMailPortalEmpleado
(@idempresa as bigint)
	with ENCRYPTION

AS
	SET NOCOUNT ON	
						
	SELECT MailServer
		  ,MailAddress
		  ,Puerto
		  ,CC
		  ,a_user
		  ,a_pwd
		  ,autenticacion
		  ,tipoAutenticacion
		  ,nombreMail
		  ,PuestoMail
		  ,cSSL
		  ,cTSL
		  ,MailRecepcionRH
		  ,IdEmpresa
		  ,idConfiguracion
	FROM configuraEmailPortalEmpleado
	where idEmpresa=@idempresa
  
GO